
#include <stdio.h>
#include <stdarg.h>
#include <assert.h>

int snprintf ( char *str, size_t size, const char *format, ... )
{
    va_list ap;
    int n;

    va_start(ap, format);

    assert ((n = vsprintf (str, format, ap)) <= size);
    return n;
}

int vsnprintf ( char *str, size_t size, const char *format, va_list ap )
{
    int n;

    assert ((n = vsprintf (str, format, ap)) <= size);
    return n;
}
