
/*  A Bison parser, made from djasm.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	KID	258
#define	UID	259
#define	OP_OR	260
#define	OP_AND	261
#define	OP_NE	262
#define	OP_LE	263
#define	OP_GE	264
#define	OP_SHL	265
#define	OP_SHR	266
#define	OP_NEG	267
#define	OP_LNOT	268
#define	OP_NOT	269
#define	NUMBER	270
#define	REG8	271
#define	REG16	272
#define	REG32	273
#define	SREG	274
#define	STRING	275
#define	PC	276
#define	CRREG	277
#define	DRREG	278
#define	TRREG	279
#define	ARITH2	280
#define	ARITH2B	281
#define	ARITH2D	282
#define	ARITH2W	283
#define	LXS	284
#define	MOVSZX	285
#define	JCC	286
#define	JCCL	287
#define	JCXZ	288
#define	LOOP	289
#define	SETCC	290
#define	SHIFT	291
#define	SHLRD	292
#define	ONEBYTE	293
#define	TWOBYTE	294
#define	ASCADJ	295
#define	BITTEST	296
#define	GROUP3	297
#define	GROUP3B	298
#define	GROUP3D	299
#define	GROUP3W	300
#define	GROUP6	301
#define	GROUP7	302
#define	ALIGN	303
#define	BSS	304
#define	CALL	305
#define	CALLF	306
#define	COPYRIGHT	307
#define	DB	308
#define	DD	309
#define	DEC	310
#define	DECB	311
#define	DECD	312
#define	DECW	313
#define	DUP	314
#define	DW	315
#define	IN	316
#define	INC	317
#define	INCB	318
#define	INCD	319
#define	INCW	320
#define	INT	321
#define	INCLUDE	322
#define	JMPW	323
#define	JMPB	324
#define	JMPF	325
#define	LINKCOFF	326
#define	MOV	327
#define	MOVB	328
#define	MOVD	329
#define	MOVW	330
#define	IMUL	331
#define	IMULB	332
#define	IMULD	333
#define	IMULW	334
#define	ORG	335
#define	OUT	336
#define	POP	337
#define	POPW	338
#define	POPD	339
#define	PUSH	340
#define	PUSHW	341
#define	PUSHD	342
#define	RCS_ID	343
#define	RET	344
#define	RETF	345
#define	RETD	346
#define	RETFD	347
#define	STACK	348
#define	START	349
#define	TEST	350
#define	TESTB	351
#define	TESTD	352
#define	TESTW	353
#define	TYPE	354
#define	XCHG	355

#line 2 "djasm.y"


#define YYDEBUG 1
  
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <coff.h>
#include <fcntl.h>
#include <time.h>

#define SMALL_EXE_HEADER 0
#if SMALL_EXE_HEADER
#define EXE_HEADER_SIZE 32
#define EXE_HEADER_BLOCKS 1
#else
#define EXE_HEADER_SIZE 512
#define EXE_HEADER_BLOCKS 32
#endif

#define YYERROR_VERBOSE

void yyerror(char *s);

#define OUT_exe 0
#define OUT_com 1
#define OUT_bin 2
#define OUT_h   3
#define OUT_inc 4
#define OUT_s   5

char *ext_types[] = {
  "exe",
  "com",
  "bin",
  "h",
  "inc",
  "ah",
  0
};

char *INC_LEADER = "\t.db\t";
char *S_LEADER = "\t.byte\t";

int out_type = OUT_exe;
int image_type = OUT_exe;
char *outname = 0;

int i;
int lineno = 1;
char *inname;
int total_errors = 0;
char last_token[100];
int last_tret;
char *copyright = 0;

int last_align_begin=-1, last_align_end=-1;
int generated_bytes = -1;

char strbuf[200];
int strbuflen;

typedef struct {
  short line;
  short addr;
} lineaddr_s;

lineaddr_s *lineaddr=0;
int num_lineaddr=0;
int max_lineaddr=0;

unsigned char *outbin = 0;
int outsize = 0;
int pc = 0;
int bsspc = -1;
int stack_ptr = 0;
int start_ptr = 0;
int movacc = 0;

typedef struct Symbol {
  struct Symbol *next;
  char *name;
  int value;
  int defined;
  struct Patch *patches;
  int first_used;
  int type;
} Symbol;

#define SYM_unknown	0
#define SYM_abs		1
#define SYM_data	2
#define SYM_code	4
#define SYMTYPES "?ADDTTTT"

#define REL_abs		0
#define REL_abs32	1
#define REL_16		2
#define REL_8		3

typedef struct Patch {
  struct Patch *next;
  int location;
  int lineno;
  int rel;
} Patch;

Symbol *symtab = 0;
Symbol *get_symbol(char *name, int create);
Symbol *set_symbol(Symbol *sym, int value);
Symbol *zerosym;

struct {
  int regs;
  int offset;
  int nsyms;
  Symbol *syms[10];
} _modrm = { 0, 0, 0 };

unsigned char sreg_overrides[] = {
  0x26, 0x2e, 0x36, 0x3e, 0x64, 0x65
};

void emit(void *v, int len);
void emitb(int b);
void emitw(int w);
void emitd(long d);
void emits(Symbol *s, int offset, int rel);
void modrm(int mod, int reg, int rm);
void reg(int reg);
void sortsyms();

int istemp(char *symname, char which);
void do_sreg_pop(int sreg);
void do_sreg_push(int sreg);
void do_align(int p2, int val);
void set_lineaddr();
void add_copyright(char *buf);
void add_rcs_ident(char *buf);

void set_out_type(char *type);
void set_image_type(char *type);
void do_include(char *fname);
void do_linkcoff(char *fname);


#line 151 "djasm.y"
typedef union {
  Symbol *sym;
  int i;
  struct {
    Symbol *sym;
    int ofs;
  } relsym;
} YYSTYPE;
#line 197 "djasm.y"

#define NO_ATTR -1

struct opcode {
  char *name;
  int token;
  int attr;
};

struct opcode opcodes[] = {
  "aaa", ONEBYTE, 0x37,
  "aad", ASCADJ, 0xd5,
  "aam", ASCADJ, 0xd4,
  "aas", ONEBYTE, 0x3f,
  "cbw", ONEBYTE, 0x98,
  "cwde", TWOBYTE, 0x6698,
  "clc", ONEBYTE, 0xf8,
  "cld", ONEBYTE, 0xfc,
  "cli", ONEBYTE, 0xfa,
  "clts", TWOBYTE, 0x0f06,
  "cmc", ONEBYTE, 0xf5,
  "cmpsb", ONEBYTE, 0xa6,
  "cmpsw", ONEBYTE, 0xa7,
  "cmpsd", TWOBYTE, 0x66a7,
  "cpuid", TWOBYTE, 0x0fa2,
  "cwd", ONEBYTE, 0x99,
  "cdq", TWOBYTE, 0x6699,
  "daa", ONEBYTE, 0x27,
  "das", ONEBYTE, 0x2f,
  "hlt", ONEBYTE, 0xf4,
  "insb", ONEBYTE, 0x6c,
  "insw", ONEBYTE, 0x6d,
  "insd", TWOBYTE, 0x666d,
  "into", ONEBYTE, 0xce,
  "iret", ONEBYTE, 0xcf,
  "iretd", TWOBYTE, 0x66cf,
  "lahf", ONEBYTE, 0x9f,
  "leave", ONEBYTE, 0xc9,
  "lock", ONEBYTE, 0xf0,
  "lodsb", ONEBYTE, 0xac,
  "lodsw", ONEBYTE, 0xad,
  "lodsd", TWOBYTE, 0x66ad,
  "movsb", ONEBYTE, 0xa4,
  "movsw", ONEBYTE, 0xa5,
  "movsd", TWOBYTE, 0x66a5,
  "nop", ONEBYTE, 0x90,
  "outsb", ONEBYTE, 0x6e,
  "outsw", ONEBYTE, 0x6f,
  "outsd", TWOBYTE, 0x666f,
  "popa", ONEBYTE, 0x61,
  "popad", TWOBYTE, 0x6661,
  "popf", ONEBYTE, 0x9d,
  "popfd", TWOBYTE, 0x669d,
  "pusha", ONEBYTE, 0x60,
  "pushad", TWOBYTE, 0x6660,
  "pushf", ONEBYTE, 0x9c,
  "pushfd", TWOBYTE, 0x669c,
  "rep", ONEBYTE, 0xf3,
  "repe", ONEBYTE, 0xf3,
  "repz", ONEBYTE, 0xf3,
  "repne", ONEBYTE, 0xf2,
  "repnz", ONEBYTE, 0xf2,
  "sahf", ONEBYTE, 0x9e,
  "scasb", ONEBYTE, 0xae,
  "scasw", ONEBYTE, 0xaf,
  "scasd", TWOBYTE, 0x66af,
  "stc", ONEBYTE, 0xf9,
  "std", ONEBYTE, 0xfd,
  "sti", ONEBYTE, 0xfb,
  "stosb", ONEBYTE, 0xaa,
  "stosw", ONEBYTE, 0xab,
  "stosd", TWOBYTE, 0x66ab,
  "wait", ONEBYTE, 0x9b,
  "fwait", ONEBYTE, 0x9b,
  "xlat", ONEBYTE, 0xd7,
  "xlatb", ONEBYTE, 0xd7,

  ".addrsize", ONEBYTE, 0x67,
  ".opsize", ONEBYTE, 0x66,
  ".segcs", ONEBYTE, 0x2e,
  ".segds", ONEBYTE, 0x3e,
  ".seges", ONEBYTE, 0x26,
  ".segss", ONEBYTE, 0x36,
  ".segfs", ONEBYTE, 0x64,
  ".seggs", ONEBYTE, 0x65,

  ".align", ALIGN, NO_ATTR,
  ".bss", BSS, NO_ATTR,
  ".copyright", COPYRIGHT, NO_ATTR,
  ".db", DB, NO_ATTR,
  ".dd", DD, NO_ATTR,
  ".dup", DUP, NO_ATTR,
  ".dw", DW, NO_ATTR,
  ".id", RCS_ID, NO_ATTR,
  ".include", INCLUDE, NO_ATTR,
  ".linkcoff", LINKCOFF, NO_ATTR,
  ".org", ORG, NO_ATTR,
  ".stack", STACK, NO_ATTR,
  ".start", START, NO_ATTR,
  ".type", TYPE, NO_ATTR,

  "adc", ARITH2, 2,
  "adcb", ARITH2B, 2,
  "adcd", ARITH2D, 2,
  "adcw", ARITH2W, 2,
  "add", ARITH2, 0,
  "addb", ARITH2B, 0,
  "addd", ARITH2D, 0,
  "addw", ARITH2W, 0,
  "and", ARITH2, 4,
  "andb", ARITH2B, 4,
  "andd", ARITH2D, 4,
  "andw", ARITH2W, 4,
  "bt", BITTEST, 4,
  "btc", BITTEST, 7,
  "btr", BITTEST, 6,
  "bts", BITTEST, 5,
  "call", CALL, NO_ATTR,
  "callf", CALLF, NO_ATTR,
  "cmp", ARITH2, 7,
  "cmpb", ARITH2B, 7,
  "cmpd", ARITH2D, 7,
  "cmpw", ARITH2W, 7,
  "dec", DEC, NO_ATTR,
  "decb", DECB, NO_ATTR,
  "decd", DECD, NO_ATTR,
  "decw", DECW, NO_ATTR,
  "div", GROUP3, 6,
  "divb", GROUP3B, 6,
  "divd", GROUP3D, 6,
  "divw", GROUP3W, 6,
  "idiv", GROUP3, 7,
  "idivb", GROUP3B, 7,
  "idivd", GROUP3D, 7,
  "idivw", GROUP3W, 7,
  "imul", IMUL, NO_ATTR,
  "imulb", IMULB, NO_ATTR,
  "imuld", IMULD, NO_ATTR,
  "imulw", IMULW, NO_ATTR,
  "in", IN, NO_ATTR,
  "inc", INC, NO_ATTR,
  "incb", INCB, NO_ATTR,
  "incd", INCD, NO_ATTR,
  "incw", INCW, NO_ATTR,
  "int", INT, NO_ATTR,

  "jo", JCC, 0,
  "jno", JCC, 1,
  "jb", JCC, 2,
  "jc", JCC, 2,
  "jnae", JCC, 2,
  "jnb", JCC, 3,
  "jnc", JCC, 3,
  "jae", JCC, 3,
  "jz", JCC, 4,
  "je", JCC, 4,
  "jnz", JCC, 5,
  "jne", JCC, 5,
  "jbe", JCC, 6,
  "jna", JCC, 6,
  "jnbe", JCC, 7,
  "ja", JCC, 7,
  "js", JCC, 8,
  "jns", JCC, 9,
  "jp", JCC, 10,
  "jpe", JCC, 10,
  "jnp", JCC, 11,
  "jpo", JCC, 11,
  "jl", JCC, 12,
  "jnge", JCC, 12,
  "jnl", JCC, 13,
  "jge", JCC, 13,
  "jle", JCC, 14,
  "jng", JCC, 14,
  "jnle", JCC, 15,
  "jg", JCC, 15,

  "jol", JCCL, 0,
  "jnol", JCCL, 1,
  "jbl", JCCL, 2,
  "jcl", JCCL, 2,
  "jnael", JCCL, 2,
  "jnbl", JCCL, 3,
  "jncl", JCCL, 3,
  "jael", JCCL, 3,
  "jzl", JCCL, 4,
  "jel", JCCL, 4,
  "jnzl", JCCL, 5,
  "jnel", JCCL, 5,
  "jbel", JCCL, 6,
  "jnal", JCCL, 6,
  "jnbel", JCCL, 7,
  "jal", JCCL, 7,
  "jsl", JCCL, 8,
  "jnsl", JCCL, 9,
  "jpl", JCCL, 10,
  "jpel", JCCL, 10,
  "jnpl", JCCL, 11,
  "jpol", JCCL, 11,
  "jll", JCCL, 12,
  "jngel", JCCL, 12,
  "jnll", JCCL, 13,
  "jgel", JCCL, 13,
  "jlel", JCCL, 14,
  "jngl", JCCL, 14,
  "jnlel", JCCL, 15,
  "jgl", JCCL, 15,

  "jcxz", JCXZ, 0,
  "jecxz", JCXZ, 1,

  "jmp", JMPB, NO_ATTR,
  "jmpf", JMPF, NO_ATTR,
  "jmpl", JMPW, NO_ATTR,
  "lds", LXS, 0xc5,
  "les", LXS, 0xc4,
  "lfs", LXS, 0x0fb4,
  "lgs", LXS, 0x0fb5,
  "lss", LXS, 0x0fb2,
  "lgdt", GROUP7, 2,
  "lidt", GROUP7, 3,
  "lldt", GROUP6, 2,
  "lmsw", GROUP7, 6,
  "loop", LOOP, 0xe2,
  "loope", LOOP, 0xe1,
  "loopne", LOOP, 0xe0,
  "loopnz", LOOP, 0xe0,
  "loopz", LOOP, 0xe1,
  "ltr", GROUP6, 3,
  "mov", MOV, NO_ATTR,
  "movb", MOVB, NO_ATTR,
  "movd", MOVD, NO_ATTR,
  "movw", MOVW, NO_ATTR,
  "movsx", MOVSZX, 0xbe,
  "movzx", MOVSZX, 0xb6,
  "mul", GROUP3, 4,
  "mulb", GROUP3B, 4,
  "muld", GROUP3D, 4,
  "mulw", GROUP3W, 4,
  "not", GROUP3, 2,
  "neg", GROUP3, 3,
  "or", ARITH2, 1,
  "orb", ARITH2B, 1,
  "ord", ARITH2D, 1,
  "orw", ARITH2W, 1,
  "out", OUT, NO_ATTR,
  "pop", POP, NO_ATTR,
  "popw", POPW, NO_ATTR,
  "popd", POPD, NO_ATTR,
  "push", PUSH, NO_ATTR,
  "pushw", PUSHW, NO_ATTR,
  "pushd", PUSHD, NO_ATTR,
  "rcl", SHIFT, 2,
  "rcr", SHIFT, 3,
  "ret", RET, NO_ATTR,
  "retd", RETD, NO_ATTR,
  "retf", RETF, NO_ATTR,
  "retfd", RETFD, NO_ATTR,
  "rol", SHIFT, 0,
  "ror", SHIFT, 1,
  "sar", SHIFT, 7,
  "sbb", ARITH2, 3,
  "sbbb", ARITH2B, 3,
  "sbbd", ARITH2D, 3,
  "sbbw", ARITH2W, 3,

  "seto", SETCC, 0,
  "setno", SETCC, 1,
  "setb", SETCC, 2,
  "setc", SETCC, 2,
  "setnae", SETCC, 2,
  "setnb", SETCC, 3,
  "setnc", SETCC, 3,
  "setae", SETCC, 3,
  "setz", SETCC, 4,
  "sete", SETCC, 4,
  "setnz", SETCC, 5,
  "setne", SETCC, 5,
  "setbe", SETCC, 6,
  "setna", SETCC, 6,
  "setnbe", SETCC, 7,
  "seta", SETCC, 7,
  "sets", SETCC, 8,
  "setns", SETCC, 9,
  "setp", SETCC, 10,
  "setpe", SETCC, 10,
  "setnp", SETCC, 11,
  "setpo", SETCC, 11,
  "setl", SETCC, 12,
  "setnge", SETCC, 12,
  "setnl", SETCC, 13,
  "setge", SETCC, 13,
  "setle", SETCC, 14,
  "setng", SETCC, 14,
  "setnle", SETCC, 15,
  "setg", SETCC, 15,

  "sgdt", GROUP7, 0,
  "sidt", GROUP7, 1,
  "sldt", GROUP6, 0,
  "sal", SHIFT, 4,
  "shl", SHIFT, 4,
  "shld", SHLRD, 0xa4,
  "shr", SHIFT, 5,
  "shrd", SHLRD, 0xac,
  "smsw", GROUP7, 4,
  "str", GROUP6, 1,
  "sub", ARITH2, 5,
  "subb", ARITH2B, 5,
  "subd", ARITH2D, 5,
  "subw", ARITH2W, 5,
  "test", TEST, NO_ATTR,
  "testb", TESTB, NO_ATTR,
  "testw", TESTW, NO_ATTR,
  "testd", TESTD, NO_ATTR,
  "verr", GROUP6, 4,
  "verw", GROUP6, 5,
  "xchg", XCHG, NO_ATTR,
  "xor", ARITH2, 6,
  "xorb", ARITH2B, 6,
  "xord", ARITH2D, 6,
  "xorw", ARITH2W, 6,

  "al", REG8, 0,
  "cl", REG8, 1,
  "dl", REG8, 2,
  "bl", REG8, 3,
  "ah", REG8, 4,
  "ch", REG8, 5,
  "dh", REG8, 6,
  "bh", REG8, 7,

  "es", SREG, 0,
  "cs", SREG, 1,
  "ss", SREG, 2,
  "ds", SREG, 3,
  "fs", SREG, 4,
  "gs", SREG, 5,

  "ax", REG16, 0,
  "cx", REG16, 1,
  "dx", REG16, 2,
  "bx", REG16, 3,
  "sp", REG16, 4,
  "bp", REG16, 5,
  "si", REG16, 6,
  "di", REG16, 7,

  "eax", REG32, 0,
  "ecx", REG32, 1,
  "edx", REG32, 2,
  "ebx", REG32, 3,
  "esp", REG32, 4,
  "ebp", REG32, 5,
  "esi", REG32, 6,
  "edi", REG32, 7,

  "cr0", CRREG, 0,
  "cr2", CRREG, 2,
  "cr3", CRREG, 3,

  "dr0", DRREG, 0,
  "dr1", DRREG, 1,
  "dr2", DRREG, 2,
  "dr3", DRREG, 3,
  "dr6", DRREG, 6,
  "dr7", DRREG, 7,

  "tr3", TRREG, 3,
  "tr4", TRREG, 4,
  "tr5", TRREG, 5,
  "tr6", TRREG, 6,
  "tr7", TRREG, 7};
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		468
#define	YYFLAG		-32768
#define	YYNTBASE	121

#define YYTRANSLATE(x) ((unsigned)(x) <= 355 ? yytranslate[x] : 136)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,   112,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   117,     2,     2,     2,    22,     9,     2,   119,
   120,    20,    18,   114,    19,     2,    21,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,   113,     2,    11,
    10,    12,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
   115,     2,   116,     7,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     6,     2,   118,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     8,    13,    14,    15,    16,    17,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
   107,   108,   109,   110,   111
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     5,    10,    15,    16,    19,    23,    28,    30,
    32,    34,    36,    39,    44,    49,    54,    59,    64,    69,
    74,    79,    84,    89,    94,    99,   104,   109,   114,   116,
   119,   122,   127,   132,   137,   142,   147,   152,   157,   162,
   165,   168,   171,   173,   176,   179,   182,   185,   188,   191,
   194,   197,   200,   205,   210,   215,   220,   225,   230,   233,
   236,   239,   242,   245,   248,   251,   254,   257,   260,   263,
   266,   271,   276,   281,   286,   293,   300,   303,   306,   309,
   312,   315,   318,   321,   324,   327,   330,   333,   336,   339,
   342,   345,   348,   351,   356,   359,   362,   367,   372,   377,
   382,   387,   392,   397,   402,   407,   412,   417,   422,   427,
   432,   437,   442,   447,   452,   457,   462,   467,   472,   477,
   482,   487,   492,   497,   502,   507,   512,   515,   520,   525,
   530,   535,   540,   545,   550,   553,   556,   559,   562,   565,
   568,   571,   574,   577,   580,   583,   586,   588,   591,   593,
   596,   598,   601,   603,   606,   609,   612,   617,   622,   627,
   632,   637,   642,   649,   656,   658,   660,   665,   670,   675,
   680,   685,   690,   695,   700,   705,   710,   715,   720,   725,
   730,   735,   738,   741,   746,   751,   756,   761,   766,   771,
   776,   781,   786,   788,   790,   794,   796,   800,   802,   805,
   809,   811,   815,   817,   820,   824,   826,   830,   835,   839,
   845,   847,   851,   855,   859,   861,   863,   865,   867,   869,
   873,   877,   881,   885,   889,   893,   897,   901,   905,   909,
   913,   917,   921,   925,   929,   933,   937,   941,   944,   947,
   950,   954,   956,   958,   961,   963,   966,   969
};

static const short yyrhs[] = {    -1,
   121,   122,   112,     0,   121,    78,    31,   112,     0,   121,
    78,    26,   112,     0,     0,   133,   113,     0,   133,    10,
   132,     0,   133,    10,    32,   135,     0,     1,     0,    49,
     0,    50,     0,    60,     0,    30,   113,     0,    37,   129,
   114,   132,     0,    36,    27,   114,   132,     0,    36,    27,
   114,    27,     0,    36,   129,   114,    27,     0,    36,    27,
   114,   129,     0,    39,   129,   114,   134,     0,    36,    28,
   114,   134,     0,    36,    28,   114,    28,     0,    36,   129,
   114,    28,     0,    36,    28,   114,   129,     0,    38,   129,
   114,   134,     0,    36,    29,   114,   134,     0,    36,    29,
   114,    29,     0,    36,   129,   114,    29,     0,    36,    29,
   114,   129,     0,    51,     0,    51,   132,     0,    59,   132,
     0,    59,   132,   114,   132,     0,    52,    28,   114,    28,
     0,    52,   129,   114,    28,     0,    52,    29,   114,    29,
     0,    52,   129,   114,    29,     0,    52,    28,   114,   132,
     0,    52,   129,   114,   132,     0,    52,    29,   114,   132,
     0,    61,   133,     0,    62,   129,     0,    63,    31,     0,
    99,     0,    64,   124,     0,    71,   126,     0,    65,   128,
     0,    66,    27,     0,    67,   129,     0,    66,    28,     0,
    66,    29,     0,    69,   129,     0,    68,   129,     0,    72,
    27,   114,   132,     0,    72,    28,   114,   132,     0,    72,
    29,   114,   132,     0,    72,    27,   114,    28,     0,    72,
    28,   114,    28,     0,    72,    29,   114,    28,     0,    73,
    27,     0,    74,   129,     0,    73,    28,     0,    73,    29,
     0,    76,   129,     0,    75,   129,     0,    87,    27,     0,
    88,   129,     0,    87,    28,     0,    90,   129,     0,    87,
    29,     0,    89,   129,     0,    87,    28,   114,    28,     0,
    87,    29,   114,    29,     0,    87,    28,   114,   129,     0,
    87,    29,   114,   129,     0,    87,    28,   114,   129,   114,
   132,     0,    87,    29,   114,   129,   114,   132,     0,    53,
    27,     0,    54,   129,     0,    53,    28,     0,    56,   129,
     0,    53,    29,     0,    55,   129,     0,    57,   129,     0,
    57,    28,     0,    58,   129,     0,    58,    28,     0,    77,
   132,     0,    42,   133,     0,    43,   133,     0,    44,   133,
     0,    79,   133,     0,    80,   133,     0,    81,   129,     0,
    81,   132,   113,   134,     0,    82,    31,     0,    45,   133,
     0,    40,    28,   114,   129,     0,    40,    29,   114,   129,
     0,    84,   129,   114,   132,     0,    83,    27,   114,   132,
     0,    83,    27,   114,    27,     0,    83,   129,   114,    27,
     0,    83,    27,   114,   129,     0,    86,   129,   114,   134,
     0,    83,    28,   114,   134,     0,    83,    28,   114,    28,
     0,    83,   129,   114,    28,     0,    83,    28,   114,   129,
     0,    85,   129,   114,   134,     0,    83,    29,   114,   134,
     0,    83,    29,   114,    29,     0,    83,   129,   114,    29,
     0,    83,    29,   114,   129,     0,    83,   129,   114,    30,
     0,    83,    28,   114,    30,     0,    83,    30,   114,   129,
     0,    83,    30,   114,    28,     0,    83,    33,   114,    29,
     0,    83,    34,   114,    29,     0,    83,    35,   114,    29,
     0,    83,    29,   114,    33,     0,    83,    29,   114,    34,
     0,    83,    29,   114,    35,     0,    41,    28,   114,    27,
     0,    41,    29,   114,    27,     0,    41,    29,   114,    28,
     0,    91,   132,     0,    91,   132,   114,   132,     0,    92,
   132,   114,    27,     0,    92,   132,   114,    28,     0,    92,
   132,   114,    29,     0,    92,    28,   114,    27,     0,    92,
    28,   114,    28,     0,    92,    28,   114,    29,     0,    93,
    28,     0,    93,    29,     0,    93,    30,     0,    94,   129,
     0,    95,   129,     0,    96,    28,     0,    96,    29,     0,
    96,    30,     0,    97,   129,     0,    98,   129,     0,    97,
   134,     0,    98,   134,     0,   100,     0,   100,   132,     0,
   101,     0,   101,   132,     0,   102,     0,   102,   132,     0,
   103,     0,   103,   132,     0,    46,    27,     0,    46,   129,
     0,    47,    27,   114,   132,     0,    47,    27,   114,    27,
     0,    47,    28,   114,   132,     0,    47,    28,   114,    27,
     0,    47,    29,   114,   132,     0,    47,    29,   114,    27,
     0,    48,    28,   114,    28,   114,   132,     0,    48,    28,
   114,    28,   114,    27,     0,   104,     0,   105,     0,   107,
   129,   114,   132,     0,   106,    27,   114,   132,     0,   106,
    27,   114,    27,     0,   106,   129,   114,    27,     0,   106,
    27,   114,   129,     0,   109,   129,   114,   134,     0,   106,
    28,   114,   134,     0,   106,    28,   114,    28,     0,   106,
   129,   114,    28,     0,   106,    28,   114,   129,     0,   108,
   129,   114,   134,     0,   106,    29,   114,   134,     0,   106,
    29,   114,    29,     0,   106,   129,   114,    29,     0,   106,
    29,   114,   129,     0,   110,    31,     0,   110,    26,     0,
   111,    27,   114,    27,     0,   111,    27,   114,   129,     0,
   111,   129,   114,    27,     0,   111,    28,   114,    28,     0,
   111,    28,   114,   129,     0,   111,   129,   114,    28,     0,
   111,    29,   114,    29,     0,   111,    29,   114,   129,     0,
   111,   129,   114,    29,     0,   132,     0,    31,     0,   132,
    70,   132,     0,   123,     0,   124,   114,   123,     0,   132,
     0,     4,   135,     0,   132,    70,   132,     0,   125,     0,
   126,   114,   125,     0,   132,     0,     4,   135,     0,   132,
    70,   132,     0,   127,     0,   128,   114,   127,     0,   131,
   115,   130,   116,     0,   115,   130,   116,     0,    30,   113,
   115,   130,   116,     0,   131,     0,   130,    18,   130,     0,
   130,    19,   132,     0,    30,   113,   131,     0,    28,     0,
     4,     0,   132,     0,    26,     0,     3,     0,   132,     5,
   132,     0,   132,     6,   132,     0,   132,     7,   132,     0,
   132,     8,   132,     0,   132,     9,   132,     0,   132,    10,
   132,     0,   132,    12,   132,     0,   132,    11,   132,     0,
   132,    15,   132,     0,   132,    14,   132,     0,   132,    13,
   132,     0,   132,    16,   132,     0,   132,    17,   132,     0,
   132,    18,   132,     0,   132,    19,   132,     0,   132,    20,
   132,     0,   132,    21,   132,     0,   132,    22,   132,     0,
    19,   132,     0,   117,   132,     0,   118,   132,     0,   119,
   132,   120,     0,     3,     0,     4,     0,     4,   135,     0,
   132,     0,    18,   132,     0,    19,   132,     0,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   577,   578,   579,   580,   584,   586,   587,   588,   589,   591,
   592,   594,   596,   598,   599,   605,   606,   607,   609,   610,
   616,   617,   618,   620,   621,   627,   628,   629,   631,   632,
   634,   635,   637,   638,   639,   640,   641,   642,   643,   645,
   646,   648,   649,   651,   652,   653,   655,   656,   657,   658,
   659,   660,   662,   663,   664,   665,   666,   667,   669,   670,
   671,   672,   673,   674,   676,   677,   678,   679,   680,   681,
   682,   683,   684,   685,   686,   696,   708,   709,   710,   711,
   712,   713,   715,   716,   717,   718,   720,   722,   723,   725,
   727,   728,   729,   730,   732,   733,   735,   736,   738,   739,
   740,   741,   747,   753,   754,   755,   756,   762,   768,   769,
   770,   771,   778,   785,   786,   787,   788,   790,   791,   792,
   793,   794,   795,   797,   798,   799,   801,   802,   804,   805,
   806,   807,   808,   809,   811,   812,   813,   814,   815,   816,
   817,   818,   819,   820,   821,   822,   824,   825,   826,   827,
   828,   829,   830,   831,   833,   834,   836,   837,   838,   839,
   840,   841,   843,   845,   849,   850,   852,   853,   854,   855,
   856,   858,   859,   860,   861,   862,   864,   865,   866,   867,
   868,   870,   871,   873,   874,   875,   876,   881,   882,   883,
   889,   890,   894,   895,   896,   900,   901,   905,   906,   907,
   911,   912,   916,   917,   918,   922,   923,   927,   928,   929,
   933,   934,   935,   939,   940,   941,   942,   946,   947,   948,
   949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
   959,   960,   961,   962,   963,   964,   965,   966,   967,   968,
   969,   973,   974,   978,   979,   983,   984,   985
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","KID","UID",
"OP_OR","'|'","'^'","OP_AND","'&'","'='","'<'","'>'","OP_NE","OP_LE","OP_GE",
"OP_SHL","OP_SHR","'+'","'-'","'*'","'/'","'%'","OP_NEG","OP_LNOT","OP_NOT",
"NUMBER","REG8","REG16","REG32","SREG","STRING","PC","CRREG","DRREG","TRREG",
"ARITH2","ARITH2B","ARITH2D","ARITH2W","LXS","MOVSZX","JCC","JCCL","JCXZ","LOOP",
"SETCC","SHIFT","SHLRD","ONEBYTE","TWOBYTE","ASCADJ","BITTEST","GROUP3","GROUP3B",
"GROUP3D","GROUP3W","GROUP6","GROUP7","ALIGN","BSS","CALL","CALLF","COPYRIGHT",
"DB","DD","DEC","DECB","DECD","DECW","DUP","DW","IN","INC","INCB","INCD","INCW",
"INT","INCLUDE","JMPW","JMPB","JMPF","LINKCOFF","MOV","MOVB","MOVD","MOVW","IMUL",
"IMULB","IMULD","IMULW","ORG","OUT","POP","POPW","POPD","PUSH","PUSHW","PUSHD",
"RCS_ID","RET","RETF","RETD","RETFD","STACK","START","TEST","TESTB","TESTD",
"TESTW","TYPE","XCHG","'\\n'","':'","','","'['","']'","'!'","'~'","'('","')'",
"lines","line","dbitem","dblist","dwitem","dwlist","dditem","ddlist","regmem",
"regmemexpr","regmemitem","const","ID","constID","offset", NULL
};
#endif

static const short yyr1[] = {     0,
   121,   121,   121,   121,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   122,   122,   123,   123,   123,   124,   124,   125,   125,   125,
   126,   126,   127,   127,   127,   128,   128,   129,   129,   129,
   130,   130,   130,   131,   131,   131,   131,   132,   132,   132,
   132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
   132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
   132,   133,   133,   134,   134,   135,   135,   135
};

static const short yyr2[] = {     0,
     0,     3,     4,     4,     0,     2,     3,     4,     1,     1,
     1,     1,     2,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     4,     1,     2,
     2,     4,     4,     4,     4,     4,     4,     4,     4,     2,
     2,     2,     1,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     4,     4,     4,     4,     4,     4,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     4,     4,     4,     4,     6,     6,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     4,     2,     2,     4,     4,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     4,     4,     4,     4,     2,     4,     4,     4,
     4,     4,     4,     4,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     1,     2,     1,     2,
     1,     2,     1,     2,     2,     2,     4,     4,     4,     4,
     4,     4,     6,     6,     1,     1,     4,     4,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
     4,     2,     2,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     1,     1,     3,     1,     3,     1,     2,     3,
     1,     3,     1,     2,     3,     1,     3,     4,     3,     5,
     1,     3,     3,     3,     1,     1,     1,     1,     1,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     2,     2,     2,
     3,     1,     1,     2,     1,     2,     2,     0
};

static const short yydefact[] = {     1,
     0,     9,   242,   243,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    10,    11,
    29,     0,     0,     0,     0,     0,     0,     0,     0,    12,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    43,   147,   149,
   151,   153,   165,   166,     0,     0,     0,     0,     0,     0,
     0,     0,    13,   219,   216,     0,   218,     0,   215,     0,
     0,     0,     0,     0,     0,     0,     0,   217,   215,     0,
     0,     0,     0,     0,     0,     0,    88,    89,    90,    96,
   155,   156,     0,     0,     0,     0,    30,   215,     0,     0,
    77,    79,    81,    78,    82,    80,    84,    83,    86,    85,
    31,    40,    41,    42,   194,   196,    44,   193,   248,   206,
    46,   203,    47,    49,    50,    48,    52,    51,   248,   201,
    45,   198,     0,     0,     0,    59,    61,    62,    60,    64,
    63,    87,     0,     0,    91,    92,    93,   217,    95,     0,
   215,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    65,    67,    69,    66,    70,    68,   127,     0,     0,   135,
   136,   137,   138,   139,   140,   141,   142,   216,   143,   217,
   145,   144,   146,   148,   150,   152,   154,     0,   215,     0,
     0,     0,     0,     0,   183,   182,     0,   215,     0,     0,
     2,     0,     6,   238,     0,     0,     0,     0,     0,     0,
   211,   239,   240,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   204,     0,     0,   199,     0,     0,     0,
     0,     0,     4,     3,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   244,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   248,     7,    16,    18,    15,    21,    23,
    20,    26,    28,    25,     0,   214,     0,     0,     0,   209,
   241,    17,    22,    27,     0,   220,   221,   222,   223,   224,
   225,   227,   226,   230,   229,   228,   231,   232,   233,   234,
   235,   236,   237,    14,   248,   245,    24,    19,    97,    98,
   124,   125,   126,   158,   157,   160,   159,   162,   161,     0,
    33,    37,    35,    39,    34,    36,    38,    32,   197,   195,
   246,   247,   207,   205,   202,   200,    56,    53,    57,    54,
    58,    55,    94,   101,   103,   100,   106,   115,   108,   105,
   111,   121,   122,   123,   113,   110,   117,   116,   118,   119,
   120,   102,   107,   112,   114,    99,   109,   104,    71,    73,
    72,    74,   128,   132,   133,   134,   129,   130,   131,   169,
   171,   168,   174,   176,   173,   179,   181,   178,   170,   175,
   180,   167,   177,   172,   184,   185,   187,   188,   190,   191,
   186,   189,   192,     8,     0,   212,   213,   208,     0,     0,
     0,   210,   164,   163,    75,    76,     0,     0
};

static const short yydefgoto[] = {     1,
    81,   136,   137,   150,   151,   140,   141,    96,   230,    97,
    98,    82,   201,   302
};

static const short yypact[] = {-32768,
   965,-32768,-32768,-32768,  -110,    28,   585,   585,   585,    -5,
    38,   119,   119,   119,   119,   369,    56,   -10,-32768,-32768,
   801,   382,    67,   585,   585,   585,   593,   598,   801,-32768,
   119,   585,   -22,   397,    18,    73,   585,   585,   585,    49,
   122,   135,   585,   585,   585,   801,   -19,   119,   119,   585,
    -3,   153,   585,   585,   585,   142,   585,   585,   585,   801,
   491,   145,   585,   585,   168,   603,   603,-32768,   801,   801,
   801,   801,-32768,-32768,   181,   585,   585,   585,   -11,   300,
   -82,    -8,-32768,-32768,-32768,   801,-32768,   -80,   -76,   -71,
   -49,   786,   801,   801,   801,   -45,   -44,  1257,-32768,   -37,
    -4,     1,    19,    24,    27,    30,-32768,-32768,-32768,-32768,
-32768,-32768,    51,    64,    85,   101,  1257,   124,   130,   139,
-32768,-32768,-32768,-32768,-32768,-32768,    37,-32768,    37,-32768,
   921,-32768,-32768,-32768,-32768,-32768,   148,  1149,   109,-32768,
   149,  1167,-32768,-32768,-32768,-32768,-32768,-32768,   109,-32768,
   155,  1239,   162,   163,   175,-32768,-32768,-32768,-32768,-32768,
-32768,  1257,   144,   173,-32768,-32768,-32768,  1113,-32768,   176,
   183,   191,    89,   192,   201,   206,   210,   211,   225,   230,
-32768,   235,   236,-32768,-32768,-32768,  1077,   239,  1095,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,    41,-32768,  1131,
-32768,-32768,-32768,  1257,  1257,  1257,  1257,   240,   241,   242,
   253,   255,   261,   262,-32768,-32768,   263,   264,   267,   268,
-32768,   342,-32768,-32768,   417,   641,   422,   651,   274,   -13,
-32768,-32768,-32768,   873,   185,   786,   801,   801,   801,   801,
   801,   801,   801,   801,   801,   801,   801,   801,   801,   801,
   801,   801,   801,   801,   801,   728,   728,   585,   585,   362,
   127,   530,   711,   738,   363,   780,   792,     7,   801,   397,
   801,   801,   801,-32768,    18,   801,-32768,    49,   801,   798,
   806,   833,-32768,-32768,   728,   427,   661,   288,   679,   361,
   364,   365,    60,   801,   728,   728,   720,   463,   801,   266,
   282,-32768,   476,   725,   524,   306,   801,   728,   728,   544,
   758,   557,   309,   109,  1257,-32768,-32768,   966,    37,-32768,
-32768,-32768,-32768,-32768,   786,-32768,   786,   786,   801,-32768,
-32768,-32768,-32768,-32768,    -2,  1272,  1272,  1272,  1285,  1285,
  1300,  1300,  1300,  1300,  1300,  1300,   171,   171,   326,   326,
-32768,-32768,-32768,  1257,   109,  1257,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,  1257,-32768,  1257,-32768,  1257,   278,
-32768,  1257,-32768,  1257,-32768,-32768,  1257,  1257,-32768,  1257,
  1257,  1257,-32768,  1257,-32768,  1257,-32768,  1257,-32768,  1257,
-32768,  1257,-32768,-32768,-32768,   966,    37,   -49,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    37,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,  1257,-32768,-32768,    37,   284,
-32768,   290,  1257,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   966,    37,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,  1257,-32768,-32768,-32768,-32768,    37,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    23,-32768,  1190,-32768,   845,   801,
   801,-32768,-32768,  1257,  1257,  1257,   402,-32768
};

static const short yypgoto[] = {-32768,
-32768,   143,-32768,   131,-32768,   147,-32768,    54,  -209,   -88,
   -21,   146,    75,  -138
};


#define	YYLAST		1322


static const short yytable[] = {   117,
   274,   222,    83,   231,   328,   329,   163,   131,   134,    84,
   277,   164,   138,   142,   215,   328,   329,   116,   152,   216,
    84,   139,   103,   104,   162,    86,   335,   169,   168,   221,
    84,    85,    87,   225,   375,   376,    86,   226,   187,   189,
   328,   329,   227,    87,   200,   200,    86,   204,   205,   206,
   207,    84,   149,    87,    88,    89,    90,    91,   272,   273,
   100,   101,   102,   228,   224,   105,   106,    86,   235,   112,
   236,   232,   233,   234,    87,   120,   255,   124,   125,   126,
   128,   130,   113,   114,   115,   133,   412,   413,   414,   415,
   146,   147,   148,   121,   122,   123,   159,   160,   161,   143,
   144,   145,   330,   167,   223,   177,   178,   179,   180,   256,
   184,   185,   186,   458,   257,   455,   193,   194,   456,   199,
   202,     3,     4,    93,    94,    95,   272,   273,   211,   212,
   213,   214,   258,   220,    93,    94,    95,   259,   462,   326,
   260,   203,    92,   261,    93,    94,    95,   231,   153,   154,
   155,  -215,  -248,   362,   363,    84,    85,   107,   108,   109,
   110,   156,   157,   158,   262,    93,    94,    95,   181,   182,
   183,    86,   190,   191,   192,   454,   132,   263,    87,   170,
   171,   172,   173,    84,    85,   174,   175,   176,   250,   251,
   252,   253,   254,   165,   166,   195,   196,   197,   264,    86,
   315,   228,   289,   318,   200,   200,    87,   208,   209,   210,
    91,   332,   333,   334,   265,   336,   337,   338,   339,   340,
   341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
   351,   352,   353,   354,   356,   356,   231,   266,   326,   231,
   365,   367,   369,   267,   372,   374,   377,   378,   138,   380,
   381,   382,   268,   142,   384,   283,   152,   386,   388,   390,
   392,   270,   275,   356,   396,   200,   200,    92,   278,    93,
    94,    95,   416,   356,   356,   280,   281,   423,   317,   320,
   323,   432,   200,   200,   284,   442,   356,   356,   282,   286,
    84,   198,   424,   425,   426,    92,   287,    93,    94,    95,
   321,   324,    84,    85,   288,   290,    86,   457,   427,   428,
   429,   359,   360,    87,   291,    99,   401,    91,    86,   292,
   402,   403,   404,   293,   294,    87,   217,   218,   219,    91,
   357,   358,   439,   440,   441,   451,   452,   453,   295,   395,
   399,   405,   408,   296,    84,   252,   253,   254,   297,   298,
   420,   422,   300,   303,   304,   305,   431,   434,   437,   393,
    86,   400,   406,   446,   448,   450,   306,    87,   307,   417,
   418,    84,    85,   314,   308,   309,   310,   311,   435,   438,
   312,   313,   443,   444,    84,    85,   327,    86,   361,   409,
   370,   459,   410,   411,    87,   111,    99,   460,    91,    84,
    86,   468,    92,   461,    93,    94,    95,    87,   385,   118,
   119,    91,   379,     0,    92,    86,    93,    94,    95,    84,
    85,   383,    87,     0,    84,   198,     0,   135,     0,    84,
    85,     0,     0,     0,     0,    86,     0,   464,   465,   466,
    86,     0,    87,   316,    99,    86,    91,    87,     0,    99,
   322,    91,    87,   394,    99,     0,    91,     0,    93,    94,
    95,     0,     0,     0,     0,    84,    85,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    84,    85,
     0,    86,     0,    92,     0,    93,    94,    95,    87,     0,
    99,   421,    91,    84,    86,     0,    92,     0,    93,    94,
    95,    87,   430,    99,     0,    91,     0,     0,     0,    86,
     0,     0,     0,    93,    94,    95,    87,     0,   188,     0,
     0,     0,     0,     0,     0,     0,    84,   198,     0,     0,
     0,    92,    84,    93,    94,    95,    92,     0,    93,    94,
    95,    92,    86,    93,    94,    95,    84,    85,    86,    87,
     0,    99,   436,    91,     0,    87,   364,     0,     0,    84,
    85,     0,    86,     0,     0,     0,     0,     0,     0,    87,
   445,    99,     0,    91,     0,    86,     0,    92,     0,    93,
    94,    95,    87,     0,    99,   449,    91,    84,    85,     0,
    92,     0,    93,    94,    95,    84,    85,     0,     0,     0,
    84,    85,     0,    86,     0,    84,   198,    93,    94,    95,
    87,    86,    99,     0,    91,     0,    86,     0,    87,     0,
   127,    86,    91,    87,     0,   129,     0,    91,    87,     0,
    99,     0,    91,     0,     0,     0,     0,     0,    92,     0,
    93,    94,    95,    84,   198,     0,    93,    94,    95,     0,
     0,     0,     0,    84,    85,     0,     0,     0,    92,    86,
    93,    94,    95,    84,   198,     0,    87,     0,   319,    86,
    91,    92,     0,    93,    94,    95,    87,     0,    99,    86,
   229,    84,    85,     0,     0,     0,    87,     0,   397,     0,
   398,     0,     0,     0,     0,     0,     0,    86,     0,    92,
     0,    93,    94,    95,    87,     0,   407,    92,    91,    93,
    94,    95,    92,    84,    93,    94,    95,    92,     0,    93,
    94,    95,    84,    85,     0,     0,     0,    84,   198,    86,
    84,   355,     0,     0,     0,     0,    87,   366,    86,     0,
    84,     0,     0,    86,     0,    87,    86,   419,     0,    91,
    87,     0,   433,    87,    91,    92,    86,    93,    94,    95,
    84,    85,     0,    87,   368,   325,     0,    93,    94,    95,
     0,     0,     0,     0,     0,    92,    86,    93,    94,    95,
     0,     0,    84,    87,     0,   447,     0,    91,    84,    85,
     0,     0,     0,    92,    84,    93,    94,    95,    86,     0,
    84,     0,     0,    84,    86,    87,     0,   371,    84,     0,
    86,    87,     0,    99,     0,   229,    86,    87,     0,    86,
   373,     0,     0,    87,    86,   387,    87,    93,    94,    95,
     0,    87,     0,   389,    92,    84,    93,    94,    95,    92,
     0,    93,    94,    95,    93,    94,    95,    84,     0,     0,
     0,    86,     0,     0,    93,    94,    95,     0,    87,     0,
   391,     0,     0,    86,     0,     0,     0,     0,     0,     0,
    87,   463,    92,     0,    93,    94,    95,   237,   238,   239,
   240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
   250,   251,   252,   253,   254,     0,    93,    94,    95,     0,
     0,     0,    93,    94,    95,     0,     0,     0,    93,    94,
    95,     0,     0,     0,    93,    94,    95,    93,    94,    95,
     0,     0,    93,    94,    95,   237,   238,   239,   240,   241,
   242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
   252,   253,   254,     0,     0,     0,     0,     0,     0,    93,
    94,    95,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    93,    94,    95,   467,     2,     0,     3,     4,     0,
   237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
   247,   248,   249,   250,   251,   252,   253,   254,     0,     0,
     0,     0,   331,     0,     5,     0,     0,     0,     0,     0,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,   269,    40,    41,    42,    43,    44,
    45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
    55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    -5,     0,     0,     0,
  -217,   237,   238,   239,   240,   241,   242,   243,   244,   245,
   246,   247,   248,   249,   250,   251,   252,   253,   254,   237,
   238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
   248,   249,   250,   251,   252,   253,   254,   237,   238,   239,
   240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
   250,   251,   252,   253,   254,   237,   238,   239,   240,   241,
   242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
   252,   253,   254,   237,   238,   239,   240,   241,   242,   243,
   244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
   254,   237,   238,   239,   240,   241,   242,   243,   244,   245,
   246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
   299,     0,     0,     0,   237,   238,   239,   240,   241,   242,
   243,   244,   245,   246,   247,   248,   249,     0,   301,   252,
   253,   254,     0,     0,     0,     0,     0,     0,   271,     0,
     0,     0,     0,     0,     0,   285,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   276,     0,     0,     0,
     0,     0,  -245,   237,   238,   239,   240,   241,   242,   243,
   244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
   254,   237,   238,   239,   240,   241,   242,   243,   244,   245,
   246,   247,   248,   249,   250,   251,   252,   253,   254,   240,
   241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
   251,   252,   253,   254,   242,   243,   244,   245,   246,   247,
   248,   249,   250,   251,   252,   253,   254,     0,   279,-32768,
-32768,-32768,-32768,-32768,-32768,   248,   249,   250,   251,   252,
   253,   254
};

static const short yycheck[] = {    21,
   139,    10,   113,    92,    18,    19,    26,    29,    31,     3,
   149,    31,    34,    35,    26,    18,    19,    28,    40,    31,
     3,     4,    28,    29,    46,    19,   236,    31,    50,   112,
     3,     4,    26,   114,    28,    29,    19,   114,    60,    61,
    18,    19,   114,    26,    66,    67,    19,    69,    70,    71,
    72,     3,     4,    26,    27,    28,    29,    30,    18,    19,
     7,     8,     9,   113,    86,    28,    29,    19,   114,    16,
   115,    93,    94,    95,    26,    22,   114,    24,    25,    26,
    27,    28,    27,    28,    29,    32,    27,    28,    29,    30,
    37,    38,    39,    27,    28,    29,    43,    44,    45,    27,
    28,    29,   116,    50,   113,    52,    53,    54,    55,   114,
    57,    58,    59,   116,   114,   325,    63,    64,   328,    66,
    67,     3,     4,   117,   118,   119,    18,    19,    75,    76,
    77,    78,   114,    80,   117,   118,   119,   114,   116,   228,
   114,    67,   115,   114,   117,   118,   119,   236,    27,    28,
    29,   115,   112,    27,    28,     3,     4,    12,    13,    14,
    15,    27,    28,    29,   114,   117,   118,   119,    27,    28,
    29,    19,    28,    29,    30,   314,    31,   114,    26,    27,
    28,    29,    30,     3,     4,    33,    34,    35,    18,    19,
    20,    21,    22,    48,    49,    28,    29,    30,   114,    19,
   222,   113,   114,   225,   226,   227,    26,    27,    28,    29,
    30,    27,    28,    29,   114,   237,   238,   239,   240,   241,
   242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
   252,   253,   254,   255,   256,   257,   325,   114,   327,   328,
   262,   263,   264,   114,   266,   267,   268,   269,   270,   271,
   272,   273,   114,   275,   276,   112,   278,   279,   280,   281,
   282,   114,   114,   285,   286,   287,   288,   115,   114,   117,
   118,   119,   294,   295,   296,   114,   114,   299,   225,   226,
   227,   303,   304,   305,   112,   307,   308,   309,   114,   114,
     3,     4,    27,    28,    29,   115,   114,   117,   118,   119,
   226,   227,     3,     4,   114,   114,    19,   329,    27,    28,
    29,   258,   259,    26,   114,    28,    29,    30,    19,   114,
    33,    34,    35,   114,   114,    26,    27,    28,    29,    30,
   256,   257,    27,    28,    29,    27,    28,    29,   114,   286,
   287,   288,   289,   114,     3,    20,    21,    22,   114,   114,
   297,   298,   114,   114,   114,   114,   303,   304,   305,   285,
    19,   287,   288,   310,   311,   312,   114,    26,   114,   295,
   296,     3,     4,    32,   114,   114,   114,   114,   304,   305,
   114,   114,   308,   309,     3,     4,   113,    19,    27,    29,
    28,   114,    29,    29,    26,    27,    28,   114,    30,     3,
    19,     0,   115,   114,   117,   118,   119,    26,   278,    28,
    29,    30,   270,    -1,   115,    19,   117,   118,   119,     3,
     4,   275,    26,    -1,     3,     4,    -1,    31,    -1,     3,
     4,    -1,    -1,    -1,    -1,    19,    -1,   459,   460,   461,
    19,    -1,    26,    27,    28,    19,    30,    26,    -1,    28,
    29,    30,    26,    27,    28,    -1,    30,    -1,   117,   118,
   119,    -1,    -1,    -1,    -1,     3,     4,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
    -1,    19,    -1,   115,    -1,   117,   118,   119,    26,    -1,
    28,    29,    30,     3,    19,    -1,   115,    -1,   117,   118,
   119,    26,    27,    28,    -1,    30,    -1,    -1,    -1,    19,
    -1,    -1,    -1,   117,   118,   119,    26,    -1,    28,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,    -1,    -1,
    -1,   115,     3,   117,   118,   119,   115,    -1,   117,   118,
   119,   115,    19,   117,   118,   119,     3,     4,    19,    26,
    -1,    28,    29,    30,    -1,    26,    27,    -1,    -1,     3,
     4,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    26,
    27,    28,    -1,    30,    -1,    19,    -1,   115,    -1,   117,
   118,   119,    26,    -1,    28,    29,    30,     3,     4,    -1,
   115,    -1,   117,   118,   119,     3,     4,    -1,    -1,    -1,
     3,     4,    -1,    19,    -1,     3,     4,   117,   118,   119,
    26,    19,    28,    -1,    30,    -1,    19,    -1,    26,    -1,
    28,    19,    30,    26,    -1,    28,    -1,    30,    26,    -1,
    28,    -1,    30,    -1,    -1,    -1,    -1,    -1,   115,    -1,
   117,   118,   119,     3,     4,    -1,   117,   118,   119,    -1,
    -1,    -1,    -1,     3,     4,    -1,    -1,    -1,   115,    19,
   117,   118,   119,     3,     4,    -1,    26,    -1,    28,    19,
    30,   115,    -1,   117,   118,   119,    26,    -1,    28,    19,
    30,     3,     4,    -1,    -1,    -1,    26,    -1,    28,    -1,
    30,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,   115,
    -1,   117,   118,   119,    26,    -1,    28,   115,    30,   117,
   118,   119,   115,     3,   117,   118,   119,   115,    -1,   117,
   118,   119,     3,     4,    -1,    -1,    -1,     3,     4,    19,
     3,     4,    -1,    -1,    -1,    -1,    26,    27,    19,    -1,
     3,    -1,    -1,    19,    -1,    26,    19,    28,    -1,    30,
    26,    -1,    28,    26,    30,   115,    19,   117,   118,   119,
     3,     4,    -1,    26,    27,   115,    -1,   117,   118,   119,
    -1,    -1,    -1,    -1,    -1,   115,    19,   117,   118,   119,
    -1,    -1,     3,    26,    -1,    28,    -1,    30,     3,     4,
    -1,    -1,    -1,   115,     3,   117,   118,   119,    19,    -1,
     3,    -1,    -1,     3,    19,    26,    -1,    28,     3,    -1,
    19,    26,    -1,    28,    -1,    30,    19,    26,    -1,    19,
    29,    -1,    -1,    26,    19,    28,    26,   117,   118,   119,
    -1,    26,    -1,    28,   115,     3,   117,   118,   119,   115,
    -1,   117,   118,   119,   117,   118,   119,     3,    -1,    -1,
    -1,    19,    -1,    -1,   117,   118,   119,    -1,    26,    -1,
    28,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,
    26,    27,   115,    -1,   117,   118,   119,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    -1,   117,   118,   119,    -1,
    -1,    -1,   117,   118,   119,    -1,    -1,    -1,   117,   118,
   119,    -1,    -1,    -1,   117,   118,   119,   117,   118,   119,
    -1,    -1,   117,   118,   119,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    -1,    -1,    -1,    -1,    -1,    -1,   117,
   118,   119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   117,   118,   119,     0,     1,    -1,     3,     4,    -1,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    -1,    -1,
    -1,    -1,   120,    -1,    30,    -1,    -1,    -1,    -1,    -1,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,   114,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
   106,   107,   108,   109,   110,   111,   112,    -1,    -1,    -1,
   115,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    -1,
   114,    -1,    -1,    -1,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    -1,   114,    20,
    21,    22,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
    -1,    -1,    -1,    -1,    -1,   113,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,
    -1,    -1,   112,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    -1,    70,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 578 "djasm.y"
{ lineno++; ;
    break;}
case 3:
#line 579 "djasm.y"
{ strbuf[strbuflen]=0; do_include(strbuf); ;
    break;}
case 4:
#line 580 "djasm.y"
{ strbuf[strbuflen]=0; do_include(strbuf); ;
    break;}
case 6:
#line 586 "djasm.y"
{ set_symbol(yyvsp[-1].sym, pc)->type |= (pc?SYM_data:SYM_code); ;
    break;}
case 7:
#line 587 "djasm.y"
{ set_symbol(yyvsp[-2].sym, yyvsp[0].i)->type = SYM_abs; ;
    break;}
case 8:
#line 588 "djasm.y"
{ set_symbol(yyvsp[-3].sym, pc + yyvsp[0].i)->type = SYM_abs; ;
    break;}
case 10:
#line 591 "djasm.y"
{ emitb(yyvsp[0].i); ;
    break;}
case 11:
#line 592 "djasm.y"
{ emitb(yyvsp[0].i>>8); emitb(yyvsp[0].i & 0xff); ;
    break;}
case 12:
#line 594 "djasm.y"
{ bsspc = pc; generated_bytes = last_align_end == pc ? last_align_begin : pc; ;
    break;}
case 13:
#line 596 "djasm.y"
{ emitb(sreg_overrides[yyvsp[-1].i]); ;
    break;}
case 14:
#line 598 "djasm.y"
{ emitb(0x80), reg(yyvsp[-3].i); emitb(yyvsp[0].i); ;
    break;}
case 15:
#line 599 "djasm.y"
{ if (yyvsp[-2].i)
					      {emitb(0x80), modrm(3, yyvsp[-3].i, yyvsp[-2].i);}
					  else
					      modrm (0,yyvsp[-3].i,4); 
					  emitb	(yyvsp[0].i);
					;
    break;}
case 16:
#line 605 "djasm.y"
{ emitb(yyvsp[-3].i*8); modrm(3, yyvsp[0].i, yyvsp[-2].i); ;
    break;}
case 17:
#line 606 "djasm.y"
{ emitb(yyvsp[-3].i*8); reg(yyvsp[0].i); ;
    break;}
case 18:
#line 607 "djasm.y"
{ emitb(yyvsp[-3].i*8+2); reg(yyvsp[-2].i); ;
    break;}
case 19:
#line 609 "djasm.y"
{ emitb(0x81); reg(yyvsp[-3].i); emits(yyvsp[0].relsym.sym,yyvsp[0].relsym.ofs,REL_abs); ;
    break;}
case 20:
#line 610 "djasm.y"
{ if (yyvsp[-2].i)
					      {emitb(0x81); modrm(3, yyvsp[-3].i, yyvsp[-2].i);}
					  else
					      modrm (0,yyvsp[-3].i,5);
					  emits(yyvsp[0].relsym.sym,yyvsp[0].relsym.ofs,REL_abs);
					;
    break;}
case 21:
#line 616 "djasm.y"
{ emitb(yyvsp[-3].i*8+1); modrm(3, yyvsp[0].i, yyvsp[-2].i); ;
    break;}
case 22:
#line 617 "djasm.y"
{ emitb(yyvsp[-3].i*8+1); reg(yyvsp[0].i); ;
    break;}
case 23:
#line 618 "djasm.y"
{ emitb(yyvsp[-3].i*8+3); reg(yyvsp[-2].i); ;
    break;}
case 24:
#line 620 "djasm.y"
{ emitb(0x66); emitb(0x81); reg(yyvsp[-3].i); emits(yyvsp[0].relsym.sym,yyvsp[0].relsym.ofs,REL_abs); emitw(yyvsp[0].relsym.ofs >> 16); ;
    break;}
case 25:
#line 621 "djasm.y"
{ emitb(0x66);
					  if (yyvsp[-2].i)
					      {emitb(0x81); modrm(3, yyvsp[-3].i, yyvsp[-2].i);}
					  else
					      modrm (0,yyvsp[-3].i,5);
					  emits(yyvsp[0].relsym.sym,yyvsp[0].relsym.ofs,REL_abs);	emitw(yyvsp[0].relsym.ofs >>	16); ;
    break;}
case 26:
#line 627 "djasm.y"
{ emitb(0x66); emitb(yyvsp[-3].i*8+1); modrm(3, yyvsp[0].i, yyvsp[-2].i); ;
    break;}
case 27:
#line 628 "djasm.y"
{ emitb(0x66); emitb(yyvsp[-3].i*8+1); reg(yyvsp[0].i); ;
    break;}
case 28:
#line 629 "djasm.y"
{ emitb(0x66); emitb(yyvsp[-3].i*8+3); reg(yyvsp[-2].i); ;
    break;}
case 29:
#line 631 "djasm.y"
{ emitb(yyvsp[0].i); emitb(0x0a); ;
    break;}
case 30:
#line 632 "djasm.y"
{ emitb(yyvsp[-1].i); emitb(yyvsp[0].i); ;
    break;}
case 31:
#line 634 "djasm.y"
{ do_align(yyvsp[0].i,0x90); ;
    break;}
case 32:
#line 635 "djasm.y"
{ do_align(yyvsp[-2].i,yyvsp[0].i); ;
    break;}
case 33:
#line 637 "djasm.y"
{ emitb(0x0f); emitb(yyvsp[-3].i*8+0x83); modrm(3, yyvsp[0].i, yyvsp[-2].i); ;
    break;}
case 34:
#line 638 "djasm.y"
{ emitb(0x0f); emitb(yyvsp[-3].i*8+0x83); reg(yyvsp[0].i); ;
    break;}
case 35:
#line 639 "djasm.y"
{ emitb(0x66); emitb(0x0f); emitb(yyvsp[-3].i*8+0x83); modrm(3, yyvsp[0].i, yyvsp[-2].i); ;
    break;}
case 36:
#line 640 "djasm.y"
{ emitb(0x66); emitb(0x0f); emitb(yyvsp[-3].i*8+0x83); reg(yyvsp[0].i); ;
    break;}
case 37:
#line 641 "djasm.y"
{ emitb(0x0f); emitb(0xba); modrm(3, yyvsp[-3].i, yyvsp[-2].i); emitb(yyvsp[0].i); ;
    break;}
case 38:
#line 642 "djasm.y"
{ emitb(0x0f); emitb(0xba); reg(yyvsp[-3].i); emitb(yyvsp[0].i); ;
    break;}
case 39:
#line 643 "djasm.y"
{ emitb(0x66); emitb(0x0f); emitb(0xba); modrm(3, yyvsp[-3].i, yyvsp[-2].i); emitb(yyvsp[0].i); ;
    break;}
case 40:
#line 645 "djasm.y"
{ emitb(0xe8); emits(yyvsp[0].sym,0,REL_16); yyvsp[0].sym->type |= SYM_code; ;
    break;}
case 41:
#line 646 "djasm.y"
{ emitb(0xff); reg(3); ;
    break;}
case 42:
#line 648 "djasm.y"
{ strbuf[strbuflen] = 0; add_copyright(strbuf); ;
    break;}
case 43:
#line 649 "djasm.y"
{ strbuf[strbuflen] = 0; add_rcs_ident(strbuf); ;
    break;}
case 47:
#line 655 "djasm.y"
{ emitb(0xfe); modrm(3, 1, yyvsp[0].i); ;
    break;}
case 48:
#line 656 "djasm.y"
{ emitb(0xfe); reg(1); ;
    break;}
case 49:
#line 657 "djasm.y"
{ emitb(0x48 + yyvsp[0].i); ;
    break;}
case 50:
#line 658 "djasm.y"
{ emitb(0x66); emitb(0x48 + yyvsp[0].i); ;
    break;}
case 51:
#line 659 "djasm.y"
{ emitb(0xff); reg(1); ;
    break;}
case 52:
#line 660 "djasm.y"
{ emitb(0x66); emitb(0xff); reg(1); ;
    break;}
case 53:
#line 662 "djasm.y"
{ emitb(0xe4); emitb(yyvsp[0].i); ;
    break;}
case 54:
#line 663 "djasm.y"
{ emitb(0xe5); emitb(yyvsp[0].i); ;
    break;}
case 55:
#line 664 "djasm.y"
{ emitb(0x66); emitb(0xe5); emitb(yyvsp[0].i);;
    break;}
case 56:
#line 665 "djasm.y"
{ emitb(0xec); ;
    break;}
case 57:
#line 666 "djasm.y"
{ emitb(0xed); ;
    break;}
case 58:
#line 667 "djasm.y"
{ emitb(0x66); emitb(0xed); ;
    break;}
case 59:
#line 669 "djasm.y"
{ emitb(0xfe); modrm(3, 0, yyvsp[0].i); ;
    break;}
case 60:
#line 670 "djasm.y"
{ emitb(0xfe); reg(0); ;
    break;}
case 61:
#line 671 "djasm.y"
{ emitb(0x40 + yyvsp[0].i); ;
    break;}
case 62:
#line 672 "djasm.y"
{ emitb(0x66); emitb(0x40 + yyvsp[0].i); ;
    break;}
case 63:
#line 673 "djasm.y"
{ emitb(0xff); reg(0); ;
    break;}
case 64:
#line 674 "djasm.y"
{ emitb(0x66); emitb(0xff); reg(0); ;
    break;}
case 65:
#line 676 "djasm.y"
{ emitb(0xf6); modrm(3, 5, yyvsp[0].i); ;
    break;}
case 66:
#line 677 "djasm.y"
{ emitb(0xf6); reg(5); ;
    break;}
case 67:
#line 678 "djasm.y"
{ emitb(0xf7); modrm(3, 5, yyvsp[0].i); ;
    break;}
case 68:
#line 679 "djasm.y"
{ emitb(0xf7); reg(5); ;
    break;}
case 69:
#line 680 "djasm.y"
{ emitb(0x66); emitb(0xf7); modrm(3, 5, yyvsp[0].i); ;
    break;}
case 70:
#line 681 "djasm.y"
{ emitb(0x66); emitb(0xf7); reg(5); ;
    break;}
case 71:
#line 682 "djasm.y"
{ emitb(0x0f); emitb(0xaf); modrm(3, yyvsp[-2].i, yyvsp[0].i);;
    break;}
case 72:
#line 683 "djasm.y"
{ emitb(0x66); emitb(0x0f); emitb(0xaf); modrm(3, yyvsp[-2].i, yyvsp[0].i);;
    break;}
case 73:
#line 684 "djasm.y"
{ emitb(0x0f); emitb(0xaf); reg(yyvsp[-2].i); ;
    break;}
case 74:
#line 685 "djasm.y"
{ emitb(0x66); emitb(0x0f); emitb(0xaf); reg(yyvsp[-2].i); ;
    break;}
case 75:
#line 686 "djasm.y"
{ if (yyvsp[0].i>=-128 && yyvsp[0].i<=127)
					      emitb(0x6b);
					  else
					      emitb(0x69);
					  reg(yyvsp[-4].i);
					  if (yyvsp[0].i>=-128 && yyvsp[0].i<=127)
					      emitb(yyvsp[0].i);
					  else
					      emitw(yyvsp[0].i);
					;
    break;}
case 76:
#line 696 "djasm.y"
{ emitb(0x66);
					  if (yyvsp[0].i>=-128 && yyvsp[0].i<=127)
					      emitb(0x6b);
					  else
					      emitb(0x69);
					  reg(yyvsp[-4].i);
					  if (yyvsp[0].i>=-128 && yyvsp[0].i<=127)
					      emitb(yyvsp[0].i&0xff);
					  else
					      emitd(yyvsp[0].i);
					;
    break;}
case 77:
#line 708 "djasm.y"
{ emitb(0xf6); modrm(3, yyvsp[-1].i, yyvsp[0].i); ;
    break;}
case 78:
#line 709 "djasm.y"
{ emitb(0xf6); reg(yyvsp[-1].i); ;
    break;}
case 79:
#line 710 "djasm.y"
{ emitb(0xf7); modrm(3, yyvsp[-1].i, yyvsp[0].i); ;
    break;}
case 80:
#line 711 "djasm.y"
{ emitb(0xf7); reg(yyvsp[-1].i); ;
    break;}
case 81:
#line 712 "djasm.y"
{ emitb(0x66); emitb(0xf7); modrm(3, yyvsp[-1].i, yyvsp[0].i); ;
    break;}
case 82:
#line 713 "djasm.y"
{ emitb(0x66); emitb(0xf7); reg(yyvsp[-1].i); ;
    break;}
case 83:
#line 715 "djasm.y"
{ emitb(0x0f); emitb(0x00); reg(yyvsp[-1].i); ;
    break;}
case 84:
#line 716 "djasm.y"
{ emitb(0x0f); emitb(0x00); modrm(3, yyvsp[-1].i, yyvsp[0].i); ;
    break;}
case 85:
#line 717 "djasm.y"
{ emitb(0x0f); emitb(0x01); reg(yyvsp[-1].i); ;
    break;}
case 86:
#line 718 "djasm.y"
{ emitb(0x0f); emitb(0x01); modrm(3, yyvsp[-1].i, yyvsp[0].i); ;
    break;}
case 87:
#line 720 "djasm.y"
{ if (yyvsp[0].i == 3) emitb(0xcc); else emitb(0xcd), emitb(yyvsp[0].i); ;
    break;}
case 88:
#line 722 "djasm.y"
{ emitb(0x70+yyvsp[-1].i); emits(yyvsp[0].sym,0,REL_8); yyvsp[0].sym->type |= SYM_code; ;
    break;}
case 89:
#line 723 "djasm.y"
{ emitb(0x0f); emitb(0x80+yyvsp[-1].i); emits(yyvsp[0].sym,0,REL_16); yyvsp[0].sym->type |= SYM_code; ;
    break;}
case 90:
#line 725 "djasm.y"
{ if (yyvsp[-1].i) emitb(0x66); emitb(0xe3); emits(yyvsp[0].sym,0,REL_8); yyvsp[0].sym->type |= SYM_code; ;
    break;}
case 91:
#line 727 "djasm.y"
{ emitb(0xe9); emits(yyvsp[0].sym,0,REL_16); yyvsp[0].sym->type |= SYM_code; ;
    break;}
case 92:
#line 728 "djasm.y"
{ emitb(0xeb); emits(yyvsp[0].sym,0,REL_8); yyvsp[0].sym->type |= SYM_code; ;
    break;}
case 93:
#line 729 "djasm.y"
{ emitb(0xff); reg(5); ;
    break;}
case 94:
#line 730 "djasm.y"
{ emitb(0xea); emits(yyvsp[0].relsym.sym,yyvsp[0].relsym.ofs,REL_abs); emitw(yyvsp[-2].i); ;
    break;}
case 95:
#line 732 "djasm.y"
{ strbuf[strbuflen]=0; do_linkcoff(strbuf); ;
    break;}
case 96:
#line 733 "djasm.y"
{ emitb(yyvsp[-1].i); emits(yyvsp[0].sym,0,REL_8); ;
    break;}
case 97:
#line 735 "djasm.y"
{ if (yyvsp[-3].i>>8) emitb(yyvsp[-3].i>>8); emitb(yyvsp[-3].i & 0xff); reg(yyvsp[-2].i); ;
    break;}
case 98:
#line 736 "djasm.y"
{ emitb(0x66); if (yyvsp[-3].i>>8) emitb(yyvsp[-3].i>>8); emitb(yyvsp[-3].i & 0xff); reg(yyvsp[-2].i); ;
    break;}
case 99:
#line 738 "djasm.y"
{ emitb(0xc6), reg(0); emitb(yyvsp[0].i); ;
    break;}
case 100:
#line 739 "djasm.y"
{ emitb(0xb0+yyvsp[-2].i); emitb(yyvsp[0].i); ;
    break;}
case 101:
#line 740 "djasm.y"
{ emitb(0x88), modrm(3, yyvsp[0].i, yyvsp[-2].i); ;
    break;}
case 102:
#line 741 "djasm.y"
{ if (yyvsp[0].i==0 && _modrm.regs==0)
					      movacc=0xa2;
					  else
					      emitb(0x88); 
					  reg(yyvsp[0].i); 
					;
    break;}
case 103:
#line 747 "djasm.y"
{ if (yyvsp[-2].i==0 && _modrm.regs==0)
					      movacc=0xa0;
					  else
					      emitb(0x8a);
					  reg(yyvsp[-2].i);
					;
    break;}
case 104:
#line 753 "djasm.y"
{ emitb(0xc7); reg(0); emits(yyvsp[0].relsym.sym,yyvsp[0].relsym.ofs,REL_abs); ;
    break;}
case 105:
#line 754 "djasm.y"
{ emitb(0xb8+yyvsp[-2].i); emits(yyvsp[0].relsym.sym,yyvsp[0].relsym.ofs,REL_abs); ;
    break;}
case 106:
#line 755 "djasm.y"
{ emitb(0x89); modrm(3, yyvsp[0].i, yyvsp[-2].i); ;
    break;}
case 107:
#line 756 "djasm.y"
{ if (yyvsp[0].i==0 && _modrm.regs==0)
					      movacc=0xa3;
					  else
					      emitb(0x89);
					  reg(yyvsp[0].i); 
					;
    break;}
case 108:
#line 762 "djasm.y"
{ if (yyvsp[-2].i==0 && _modrm.regs==0)
					      movacc=0xa1;
					  else
					      emitb(0x8b);
					  reg(yyvsp[-2].i);
					;
    break;}
case 109:
#line 768 "djasm.y"
{ emitb(0x66); emitb(0xc7); reg(0); emits(yyvsp[0].relsym.sym,yyvsp[0].relsym.ofs,REL_abs); emitw(yyvsp[0].relsym.ofs >> 16); ;
    break;}
case 110:
#line 769 "djasm.y"
{ emitb(0x66); emitb(0xb8+yyvsp[-2].i); emits(yyvsp[0].relsym.sym,yyvsp[0].relsym.ofs,REL_abs); emitw(yyvsp[0].relsym.ofs >> 16); ;
    break;}
case 111:
#line 770 "djasm.y"
{ emitb(0x66); emitb(0x89); modrm(3, yyvsp[0].i, yyvsp[-2].i); ;
    break;}
case 112:
#line 771 "djasm.y"
{ emitb(0x66);
					  if (yyvsp[0].i==0 && _modrm.regs==0)
					      movacc=0xa3;
					  else
					      emitb(0x89);
					  reg(yyvsp[0].i);
					;
    break;}
case 113:
#line 778 "djasm.y"
{ emitb(0x66);
					  if (yyvsp[-2].i==0 && _modrm.regs==0)
					      movacc=0xa1;
					  else
					      emitb(0x8b);
					  reg(yyvsp[-2].i);
					;
    break;}
case 114:
#line 785 "djasm.y"
{ emitb(0x8c); reg(yyvsp[0].i); ;
    break;}
case 115:
#line 786 "djasm.y"
{ emitb(0x8c); modrm(3, yyvsp[0].i, yyvsp[-2].i); ;
    break;}
case 116:
#line 787 "djasm.y"
{ emitb(0x8e); reg(yyvsp[-2].i); ;
    break;}
case 117:
#line 788 "djasm.y"
{ emitb(0x8e); modrm(3, yyvsp[-2].i, yyvsp[0].i); ;
    break;}
case 118:
#line 790 "djasm.y"
{ emitb(0x0f); emitb(0x22); modrm(3, yyvsp[-2].i, yyvsp[0].i); ;
    break;}
case 119:
#line 791 "djasm.y"
{ emitb(0x0f); emitb(0x23); modrm(3, yyvsp[-2].i, yyvsp[0].i); ;
    break;}
case 120:
#line 792 "djasm.y"
{ emitb(0x0f); emitb(0x26); modrm(3, yyvsp[-2].i, yyvsp[0].i); ;
    break;}
case 121:
#line 793 "djasm.y"
{ emitb(0x0f); emitb(0x20); modrm(3, yyvsp[0].i, yyvsp[-2].i); ;
    break;}
case 122:
#line 794 "djasm.y"
{ emitb(0x0f); emitb(0x21); modrm(3, yyvsp[0].i, yyvsp[-2].i); ;
    break;}
case 123:
#line 795 "djasm.y"
{ emitb(0x0f); emitb(0x24); modrm(3, yyvsp[0].i, yyvsp[-2].i); ;
    break;}
case 124:
#line 797 "djasm.y"
{ emitb(0x0f); emitb(yyvsp[-3].i); modrm(3, yyvsp[-2].i, yyvsp[0].i); ;
    break;}
case 125:
#line 798 "djasm.y"
{ emitb(0x66); emitb(0x0f); emitb(yyvsp[-3].i); modrm(3, yyvsp[-2].i, yyvsp[0].i); ;
    break;}
case 126:
#line 799 "djasm.y"
{ emitb(0x66); emitb(0x0f); emitb(yyvsp[-3].i+1); modrm(3, yyvsp[-2].i, yyvsp[0].i); ;
    break;}
case 127:
#line 801 "djasm.y"
{ if (pc > yyvsp[0].i) yyerror ("Backwards org directive"); else while (pc < yyvsp[0].i) emitb(0x90); ;
    break;}
case 128:
#line 802 "djasm.y"
{ if (pc > yyvsp[-2].i) yyerror ("Backwards org directive"); else while (pc < yyvsp[-2].i) emitb(yyvsp[0].i); ;
    break;}
case 129:
#line 804 "djasm.y"
{ emitb(0xe6); emitb(yyvsp[-2].i); ;
    break;}
case 130:
#line 805 "djasm.y"
{ emitb(0xe7); emitb(yyvsp[-2].i); ;
    break;}
case 131:
#line 806 "djasm.y"
{ emitb(0x66); emitb(0xe7); emitb(yyvsp[-2].i);;
    break;}
case 132:
#line 807 "djasm.y"
{ emitb(0xee); ;
    break;}
case 133:
#line 808 "djasm.y"
{ emitb(0xef); ;
    break;}
case 134:
#line 809 "djasm.y"
{ emitb(0x66); emitb(0xef); ;
    break;}
case 135:
#line 811 "djasm.y"
{ emitb(0x58 + yyvsp[0].i); ;
    break;}
case 136:
#line 812 "djasm.y"
{ emitb(0x66); emitb(0x58 + yyvsp[0].i); ;
    break;}
case 137:
#line 813 "djasm.y"
{ do_sreg_pop(yyvsp[0].i); ;
    break;}
case 138:
#line 814 "djasm.y"
{ emitb(0x8f); reg(0); ;
    break;}
case 139:
#line 815 "djasm.y"
{ emitb(0x66); emitb(0x8f); reg(0); ;
    break;}
case 140:
#line 816 "djasm.y"
{ emitb(0x50 + yyvsp[0].i); ;
    break;}
case 141:
#line 817 "djasm.y"
{ emitb(0x66); emitb(0x50 + yyvsp[0].i); ;
    break;}
case 142:
#line 818 "djasm.y"
{ do_sreg_push(yyvsp[0].i); ;
    break;}
case 143:
#line 819 "djasm.y"
{ emitb(0xff); reg(6); ;
    break;}
case 144:
#line 820 "djasm.y"
{ emitb(0x66); emitb(0xff); reg(6); ;
    break;}
case 145:
#line 821 "djasm.y"
{ emitb(0x68); emits(yyvsp[0].relsym.sym,yyvsp[0].relsym.ofs,REL_abs); ;
    break;}
case 146:
#line 822 "djasm.y"
{ emitb(0x66); emitb(0x68); emits(yyvsp[0].relsym.sym,yyvsp[0].relsym.ofs,REL_abs); emitw(yyvsp[0].relsym.ofs >> 16); ;
    break;}
case 147:
#line 824 "djasm.y"
{ emitb(0xc3); ;
    break;}
case 148:
#line 825 "djasm.y"
{ emitb(0xc2); emitw(yyvsp[0].i); ;
    break;}
case 149:
#line 826 "djasm.y"
{ emitb(0xcb); ;
    break;}
case 150:
#line 827 "djasm.y"
{ emitb(0xca); emitw(yyvsp[0].i); ;
    break;}
case 151:
#line 828 "djasm.y"
{ emitb(0x66); emitb(0xc3); ;
    break;}
case 152:
#line 829 "djasm.y"
{ emitb(0x66); emitb(0xc2); emitd(yyvsp[0].i); ;
    break;}
case 153:
#line 830 "djasm.y"
{ emitb(0x66); emitb(0xcb); ;
    break;}
case 154:
#line 831 "djasm.y"
{ emitb(0x66); emitb(0xca); emitd(yyvsp[0].i); ;
    break;}
case 155:
#line 833 "djasm.y"
{ emitb(0x0f); emitb(0x90+yyvsp[-1].i); modrm(3, 0, yyvsp[0].i); ;
    break;}
case 156:
#line 834 "djasm.y"
{ emitb(0x0f); emitb(0x90+yyvsp[-1].i); reg(0); ;
    break;}
case 157:
#line 836 "djasm.y"
{ emitb(yyvsp[0].i == 1 ? 0xd0 : 0xc0); modrm(3, yyvsp[-3].i, yyvsp[-2].i); if (yyvsp[0].i != 1) emitb(yyvsp[0].i); ;
    break;}
case 158:
#line 837 "djasm.y"
{ if (yyvsp[0].i != 1) yyerror ("Non-constant shift count must be `cl'"); emitb(0xd2); modrm(3, yyvsp[-3].i, yyvsp[-2].i); ;
    break;}
case 159:
#line 838 "djasm.y"
{ emitb(yyvsp[0].i == 1 ? 0xd1 : 0xc1); modrm(3, yyvsp[-3].i, yyvsp[-2].i); if (yyvsp[0].i != 1) emitb(yyvsp[0].i); ;
    break;}
case 160:
#line 839 "djasm.y"
{ if (yyvsp[0].i != 1) yyerror ("Non-constant shift count must be `cl'"); emitb(0xd3); modrm(3, yyvsp[-3].i, yyvsp[-2].i); ;
    break;}
case 161:
#line 840 "djasm.y"
{ emitb(0x66); emitb(yyvsp[0].i == 1 ? 0xd1 : 0xc1); modrm(3, yyvsp[-3].i, yyvsp[-2].i); if (yyvsp[0].i != 1) emitb(yyvsp[0].i); ;
    break;}
case 162:
#line 841 "djasm.y"
{ if (yyvsp[0].i != 1) yyerror ("Non-constant shift count must be `cl'"); emitb(0x66); emitb(0xd3); modrm(3, yyvsp[-3].i, yyvsp[-2].i); ;
    break;}
case 163:
#line 844 "djasm.y"
{ emitb(0x0f); emitb(yyvsp[-5].i); modrm(3, yyvsp[-2].i, yyvsp[-4].i); emitb(yyvsp[0].i); ;
    break;}
case 164:
#line 846 "djasm.y"
{ if (yyvsp[0].i != 1) yyerror ("Non-constant shift count must be `cl'");
	    emitb(0x0f); emitb(yyvsp[-5].i+1); modrm(3, yyvsp[-2].i, yyvsp[-4].i); ;
    break;}
case 165:
#line 849 "djasm.y"
{ stack_ptr = pc; ;
    break;}
case 166:
#line 850 "djasm.y"
{ start_ptr = pc; ;
    break;}
case 167:
#line 852 "djasm.y"
{ emitb(0xf6), reg(0); emitb(yyvsp[0].i); ;
    break;}
case 168:
#line 853 "djasm.y"
{ emitb(0xf6), modrm(3, 0, yyvsp[-2].i); emitb(yyvsp[0].i); ;
    break;}
case 169:
#line 854 "djasm.y"
{ emitb(0x84), modrm(3, yyvsp[0].i, yyvsp[-2].i); ;
    break;}
case 170:
#line 855 "djasm.y"
{ emitb(0x84), reg(yyvsp[0].i); ;
    break;}
case 171:
#line 856 "djasm.y"
{ emitb(0x84), reg(yyvsp[-2].i); ;
    break;}
case 172:
#line 858 "djasm.y"
{ emitb(0xf7); reg(0); emits(yyvsp[0].relsym.sym,yyvsp[0].relsym.ofs,REL_abs); ;
    break;}
case 173:
#line 859 "djasm.y"
{ emitb(0xf7); modrm(3, 0, yyvsp[-2].i); emits(yyvsp[0].relsym.sym,yyvsp[0].relsym.ofs,REL_abs); ;
    break;}
case 174:
#line 860 "djasm.y"
{ emitb(0x85); modrm(3, yyvsp[0].i, yyvsp[-2].i); ;
    break;}
case 175:
#line 861 "djasm.y"
{ emitb(0x85); reg(yyvsp[0].i); ;
    break;}
case 176:
#line 862 "djasm.y"
{ emitb(0x85); reg(yyvsp[-2].i); ;
    break;}
case 177:
#line 864 "djasm.y"
{ emitb(0x66); emitb(0xf7); reg(0); emits(yyvsp[0].relsym.sym,yyvsp[0].relsym.ofs,REL_abs); emitw(yyvsp[0].relsym.ofs >> 16); ;
    break;}
case 178:
#line 865 "djasm.y"
{ emitb(0x66); emitb(0xf7); modrm(3, 0, yyvsp[-2].i); emits(yyvsp[0].relsym.sym,yyvsp[0].relsym.ofs,REL_abs); emitw(yyvsp[0].relsym.ofs >> 16); ;
    break;}
case 179:
#line 866 "djasm.y"
{ emitb(0x66); emitb(0x85); modrm(3, yyvsp[0].i, yyvsp[-2].i); ;
    break;}
case 180:
#line 867 "djasm.y"
{ emitb(0x66); emitb(0x85); reg(yyvsp[0].i); ;
    break;}
case 181:
#line 868 "djasm.y"
{ emitb(0x66); emitb(0x85); reg(yyvsp[-2].i); ;
    break;}
case 182:
#line 870 "djasm.y"
{ strbuf[strbuflen] = 0; set_image_type(strbuf); ;
    break;}
case 183:
#line 871 "djasm.y"
{ if (yyvsp[0].i == 'h') set_out_type("h"); ;
    break;}
case 184:
#line 873 "djasm.y"
{ emitb(0x86); modrm(3, yyvsp[-2].i, yyvsp[0].i); ;
    break;}
case 185:
#line 874 "djasm.y"
{ emitb(0x86); reg(yyvsp[-2].i); ;
    break;}
case 186:
#line 875 "djasm.y"
{ emitb(0x86); reg(yyvsp[0].i); ;
    break;}
case 187:
#line 876 "djasm.y"
{ if ((yyvsp[-2].i==0) ^	(yyvsp[0].i==0))
					      emitb(0x90+yyvsp[-2].i+yyvsp[0].i);
					  else
					      {emitb(0x87); modrm(3, yyvsp[-2].i, yyvsp[0].i); }
					;
    break;}
case 188:
#line 881 "djasm.y"
{ emitb(0x87); reg(yyvsp[-2].i); ;
    break;}
case 189:
#line 882 "djasm.y"
{ emitb(0x87); reg(yyvsp[0].i); ;
    break;}
case 190:
#line 883 "djasm.y"
{ emitb(0x66);
					  if ((yyvsp[-2].i==0) ^	(yyvsp[0].i==0))
					      emitb(0x90+yyvsp[-2].i+yyvsp[0].i);
					  else
					      {emitb(0x87); modrm(3, yyvsp[-2].i, yyvsp[0].i); }
					;
    break;}
case 191:
#line 889 "djasm.y"
{ emitb(0x66); emitb(0x87); reg(yyvsp[-2].i); ;
    break;}
case 192:
#line 890 "djasm.y"
{ emitb(0x66); emitb(0x87); reg(yyvsp[0].i); ;
    break;}
case 193:
#line 894 "djasm.y"
{ emitb(yyvsp[0].i); ;
    break;}
case 194:
#line 895 "djasm.y"
{ emit(strbuf, strbuflen); ;
    break;}
case 195:
#line 896 "djasm.y"
{ for (i=0; i<yyvsp[-2].i; i++) emitb(yyvsp[0].i); ;
    break;}
case 198:
#line 905 "djasm.y"
{ emitw(yyvsp[0].i); ;
    break;}
case 199:
#line 906 "djasm.y"
{ emits(yyvsp[-1].sym,yyvsp[0].i,REL_abs); ;
    break;}
case 200:
#line 907 "djasm.y"
{ for (i=0; i<yyvsp[-2].i; i++) emitw(yyvsp[0].i); ;
    break;}
case 203:
#line 916 "djasm.y"
{ emitd(yyvsp[0].i); ;
    break;}
case 204:
#line 917 "djasm.y"
{ emits(yyvsp[-1].sym,yyvsp[0].i,REL_abs); emitw(0); ;
    break;}
case 205:
#line 918 "djasm.y"
{ for (i=0; i<yyvsp[-2].i; i++) emitd(yyvsp[0].i); ;
    break;}
case 210:
#line 929 "djasm.y"
{ emitb(sreg_overrides[yyvsp[-4].i]); ;
    break;}
case 213:
#line 935 "djasm.y"
{ _modrm.offset -= yyvsp[0].i; ;
    break;}
case 214:
#line 939 "djasm.y"
{ emitb(sreg_overrides[yyvsp[-2].i]); ;
    break;}
case 215:
#line 940 "djasm.y"
{ _modrm.regs |= (1<<yyvsp[0].i); ;
    break;}
case 216:
#line 941 "djasm.y"
{ _modrm.syms[_modrm.nsyms++] = yyvsp[0].sym; ;
    break;}
case 217:
#line 942 "djasm.y"
{ _modrm.offset += yyvsp[0].i; ;
    break;}
case 218:
#line 946 "djasm.y"
{ yyval.i = yyvsp[0].i; ;
    break;}
case 219:
#line 947 "djasm.y"
{ yyval.i = yyvsp[0].sym->value; ;
    break;}
case 220:
#line 948 "djasm.y"
{ yyval.i = yyvsp[-2].i || yyvsp[0].i; ;
    break;}
case 221:
#line 949 "djasm.y"
{ yyval.i = yyvsp[-2].i | yyvsp[0].i; ;
    break;}
case 222:
#line 950 "djasm.y"
{ yyval.i = yyvsp[-2].i ^ yyvsp[0].i; ;
    break;}
case 223:
#line 951 "djasm.y"
{ yyval.i = yyvsp[-2].i && yyvsp[0].i; ;
    break;}
case 224:
#line 952 "djasm.y"
{ yyval.i = yyvsp[-2].i & yyvsp[0].i; ;
    break;}
case 225:
#line 953 "djasm.y"
{ yyval.i = yyvsp[-2].i == yyvsp[0].i; ;
    break;}
case 226:
#line 954 "djasm.y"
{ yyval.i = yyvsp[-2].i > yyvsp[0].i; ;
    break;}
case 227:
#line 955 "djasm.y"
{ yyval.i = yyvsp[-2].i < yyvsp[0].i; ;
    break;}
case 228:
#line 956 "djasm.y"
{ yyval.i = yyvsp[-2].i >= yyvsp[0].i; ;
    break;}
case 229:
#line 957 "djasm.y"
{ yyval.i = yyvsp[-2].i <= yyvsp[0].i; ;
    break;}
case 230:
#line 958 "djasm.y"
{ yyval.i = yyvsp[-2].i != yyvsp[0].i; ;
    break;}
case 231:
#line 959 "djasm.y"
{ yyval.i = yyvsp[-2].i << yyvsp[0].i; ;
    break;}
case 232:
#line 960 "djasm.y"
{ yyval.i = yyvsp[-2].i >> yyvsp[0].i; ;
    break;}
case 233:
#line 961 "djasm.y"
{ yyval.i = yyvsp[-2].i + yyvsp[0].i; ;
    break;}
case 234:
#line 962 "djasm.y"
{ yyval.i = yyvsp[-2].i - yyvsp[0].i; ;
    break;}
case 235:
#line 963 "djasm.y"
{ yyval.i = yyvsp[-2].i * yyvsp[0].i; ;
    break;}
case 236:
#line 964 "djasm.y"
{ yyval.i = yyvsp[-2].i / yyvsp[0].i; ;
    break;}
case 237:
#line 965 "djasm.y"
{ yyval.i = yyvsp[-2].i % yyvsp[0].i; ;
    break;}
case 238:
#line 966 "djasm.y"
{ yyval.i = -yyvsp[0].i; ;
    break;}
case 239:
#line 967 "djasm.y"
{ yyval.i = !yyvsp[0].i; ;
    break;}
case 240:
#line 968 "djasm.y"
{ yyval.i = ~yyvsp[0].i; ;
    break;}
case 241:
#line 969 "djasm.y"
{ yyval.i = yyvsp[-1].i; ;
    break;}
case 242:
#line 973 "djasm.y"
{ yyval.sym = yyvsp[0].sym; ;
    break;}
case 243:
#line 974 "djasm.y"
{ yyval.sym = yyvsp[0].sym; ;
    break;}
case 244:
#line 978 "djasm.y"
{ yyval.relsym.sym = yyvsp[-1].sym; yyval.relsym.ofs = yyvsp[0].i; ;
    break;}
case 245:
#line 979 "djasm.y"
{ yyval.relsym.sym = zerosym; yyval.relsym.ofs = yyvsp[0].i; ;
    break;}
case 246:
#line 983 "djasm.y"
{ yyval.i = yyvsp[0].i; ;
    break;}
case 247:
#line 984 "djasm.y"
{ yyval.i = -yyvsp[0].i; ;
    break;}
case 248:
#line 985 "djasm.y"
{ yyval.i = 0; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 987 "djasm.y"
 /***********************************************************************/

typedef struct FileStack {
  struct FileStack *prev;
  FILE *f;
  int line;
  char *name;
} FileStack;

FileStack *file_stack = 0;

FILE *infile;
FILE *outfile;

int scmp_a(void const *a, void const *b)
{
  return strcmp((*(Symbol **)a)->name, (*(Symbol **)b)->name);
}

int scmp_n(void const *a, void const *b)
{
  return (*(Symbol **)a)->value - (*(Symbol **)b)->value;
}

static int
opcode_compare (const void *e1, const void *e2)
{
  return strcmp (((struct opcode *)e1)->name, ((struct opcode *)e2)->name);
}

main(int argc, char **argv)
{
  Symbol *s;
  Patch *p;
  unsigned char exe[EXE_HEADER_SIZE+4];
  int undefs=0;
  int symcount = 0;
  int min_uninit;
  time_t now;
  char *outfilename, *leader;

  /* Sort the opcodes now so that we can use `bsearch' later.  */
  qsort (opcodes,
	 sizeof (opcodes) / sizeof (opcodes[0]),
	 sizeof (opcodes[0]),
	 opcode_compare);
  zerosym = set_symbol (get_symbol ("__zero__", 1), 0);

  if (argc < 2)
  {
    printf("usage: djasm infile [outfile] [mapfile]\n");
    exit(1);
  }
  inname = argv[1];
  infile = fopen(argv[1], "r");
  if (infile == 0)
  {
    fprintf(stderr, "Error: cannot open file %s for reading\n", argv[1]);
    perror("The error was");
    exit(1);
  }
  yyparse();
  fclose(infile);
  if (bsspc == -1)
  {
    bsspc = pc;
    generated_bytes = last_align_end==pc ? last_align_begin : pc;
  }

  sortsyms(scmp_a);

  for (s=symtab; s; s=s->next)
  {
    if (!istemp(s->name, 0))
      symcount++;
    if (!s->defined && s->patches)
    {
      fprintf(stderr, "Undefined symbol `%s', first used on line %d\n", s->name, s->first_used);
      for (p=s->patches; p; p=p->next)
        printf("\treferenced on line %d\n", p->lineno);
      undefs++;
    }
  }
  if (undefs)
    return 1;
  if (total_errors)
  {
    fprintf(stderr, "%d errors\n", total_errors);
    return 1;
  }

  printf("%#x bytes generated, %#x bytes in file, %#x bytes total, %d symbols\n",
    generated_bytes, bsspc, pc, symcount);

  min_uninit = (pc-bsspc+15)/16;

  memset(exe, 0, EXE_HEADER_SIZE+4);
  exe[0] = 0x4d;		/* MAGIC */
  exe[1] = 0x5a;
  exe[2] = bsspc;		/* bytes in last page */
  exe[3] = (bsspc>>8)&1;
  exe[4] = (bsspc+1023)>>9;	/* number of sectors */
  exe[5] = (bsspc+1023)>>17;
  exe[6] = 0;			/* relocation entries */
  exe[7] = 0;
  exe[8] = EXE_HEADER_BLOCKS;	/* blocks in header */
  exe[9] = 0;
  exe[10] = min_uninit;		/* min uninitialized paragraphs */
  exe[11] = (min_uninit>>8);
  exe[12] = 0xff;		/* max uninitialized paragraphs */
  exe[13] = 0xff;
  exe[14] = 0;			/* relative SS */
  exe[15] = 0;
  exe[16] = stack_ptr;		/* SP */
  exe[17] = stack_ptr>>8;
  exe[18] = 0;			/* checksum */
  exe[19] = 0;
  exe[20] = start_ptr;		/* IP */
  exe[21] = start_ptr >> 8;
  exe[22] = 0;			/* relative CS */
  exe[23] = 0;

  time(&now);
  sprintf(exe+24, "\r\n%s generated from %s by djasm, on %.24s\r\n", argv[2], argv[1], ctime(&now));
  if (copyright)
    strncat(exe+32, copyright, 480-strlen(exe+32));
  strcat(exe+32, "\r\n\032");

  if (argv[2] == 0)
  {
    char *dot=0, *sl=0, *cp;
    outfilename = (char *)malloc(strlen(argv[1])+5);
    strcpy(outfilename, argv[1]);
    for (cp=outfilename; *cp; cp++)
    {
      if (*cp == ':' || *cp == '\\' || *cp == '/')
      {
        sl = cp+1;
        dot = 0;
      }
      if (*cp == '.')
        dot = cp;
    }
    if (!dot)
    {
      dot = cp;
      *dot = '.';
    }
    strcpy(dot+1, ext_types[out_type]);
  }
  else
  {
    char *dot=0, *sl=0, *cp;
    outfilename = argv[2];
    for (cp=outfilename; *cp; cp++)
    {
      if (*cp == ':' || *cp == '\\' || *cp == '/')
      {
        sl = cp+1;
        dot = 0;
      }
      if (*cp == '.')
        dot = cp;
    }
    if (!dot)
    {
      sl = (char *)malloc(strlen(outfilename)+5);
      strcpy(sl, outfilename);
      outfilename = sl;
      dot = outfilename + strlen(outfilename);
      *dot = '.';
      strcpy(dot+1, ext_types[out_type]);
    }
    else
      set_out_type(dot+1);
  }

  switch (out_type)
  {
    case OUT_exe:
    case OUT_com:
    case OUT_bin:
      outfile = fopen(outfilename, "wb");
      break;
    case OUT_h:
    case OUT_inc:
    case OUT_s:
      outfile = fopen(outfilename, "w");
      break;
  }
  if (outfile == 0)
  {
    fprintf(stderr, "Error: cannot open file %s for writing\n", outfilename);
    perror("The error was");
    exit(1);
  }

  switch (out_type)
  {
    case OUT_exe:
      fwrite(exe, EXE_HEADER_SIZE, 1, outfile);
      fwrite(outbin, bsspc, 1, outfile);
      break;

    case OUT_com:
      fwrite(outbin+256, bsspc-256, 1, outfile);
      break;

    case OUT_bin:
      fwrite(outbin, bsspc, 1, outfile);
      break;

    case OUT_h:
      if (image_type == OUT_exe)
        for (i=0; i<EXE_HEADER_SIZE; i++)
        {
          fprintf(outfile, "0x%02x,", exe[i]);
          if ((i&15) == 15)
            fputc('\n', outfile);
        }
      for (i=((image_type==OUT_com)?0x100:0); i<bsspc; i++)
      {
        fprintf(outfile, "0x%02x", outbin[i]);
        if (i<bsspc-1)
          fputc(',', outfile);
        if ((i&15) == 15)
          fputc('\n', outfile);
      }
      if (i&15)
        fputc('\n', outfile);
      break;

    case OUT_inc:
    case OUT_s:
      if (out_type == OUT_inc)
        leader = INC_LEADER;
      else
        leader = S_LEADER;
      if (image_type == OUT_exe)
        for (i=0; i<EXE_HEADER_SIZE; i++)
        {
	  if ((i%15) == 0)
	    fputs(leader, outfile);
          fprintf(outfile, "0x%02x", exe[i]);
          if ((i&15) == 15)
          {
            fputc('\n', outfile);
          }
          else
            fputc(',', outfile);
        }
      for (i=((image_type==OUT_com)?0x100:0); i<bsspc; i++)
      {
	if ((i&15) == 0)
	  fputs(leader, outfile);
        fprintf(outfile, "0x%02x", outbin[i]);
        if ((i&15) == 15)
        {
          fputc('\n', outfile);
        }
        else
          if (i<bsspc-1)
            fputc(',', outfile);
      }
      if (i&15)
        fputc('\n', outfile);
      break;
  }
  fclose(outfile);
  
  if (argc > 3)
  {
    FILE *mapfile = fopen(argv[3], "w");
    fprintf(mapfile, "%#x bytes generated, %#x bytes in file, %#x bytes total, %d symbols\n",
      generated_bytes, bsspc, pc, symcount);

    fprintf(mapfile, "\nStart Stop  Length Name Class\n");
    fprintf(mapfile, "%04XH %04XH %04XH  code code\n", 0, pc-1, pc);

    fprintf(mapfile, "\nAddress    Symbols by Name\n\n");
    for (s = symtab; s; s=s->next)
      if (!istemp(s->name, 0))
        fprintf(mapfile, "0000:%04X  %s (%c)\n", s->value, s->name, SYMTYPES[s->type]);
    fprintf(mapfile, "\nAddress    Symbols by Value\n\n");
    sortsyms(scmp_n);
    for (s = symtab; s; s=s->next)
      if (!istemp(s->name, 0))
        fprintf(mapfile, "0000:%04X  %s (%c)\n", s->value, s->name, SYMTYPES[s->type]);
    fprintf(mapfile, "\nLine numbers for (%s)\n", argv[1]);
    for (i=0; i<num_lineaddr; i++)
    {
      fprintf(mapfile, "%5d 0000:%04X", lineaddr[i].line, lineaddr[i].addr);
      if ((i & 3) == 3)
        fputc('\n', mapfile);
      else
        fputc(' ', mapfile);
    }
    fputc('\n', mapfile);
    fclose(mapfile);
  }
}

void yyerror(char *s)
{
  fprintf(stderr, "%s:%d: %s\n", inname, lineno, s);
  strbuf[strbuflen] = 0;
  fprintf(stderr, "Last token was `%s' (%s)\n", last_token, yytname[yytranslate[last_tret]]);
  total_errors++;
}

Symbol *get_symbol(char *name, int create)
{
  Symbol *s;
  for (s=symtab; s; s=s->next)
    if (strcmp(name, s->name) == 0)
      return s;
  if (!create)
    return 0;
  s = (Symbol *)malloc(sizeof(Symbol));
  s->next = symtab;
  symtab = s;
  s->name = (char *)malloc(strlen(name)+1);
  strcpy(s->name, name);
  s->value = 0;
  s->defined = 0;
  s->patches = 0;
  s->first_used = lineno;
  s->type = SYM_unknown;
  return s;
}

Symbol *set_symbol(Symbol *s, int value)
{
  if (istemp(s->name, 'b'))
    s->defined = 0;
  if (s->defined)
    printf("Warning: symbol %s redefined\n", s->name);
  s->value = value;
  s->defined = 1;
  while (s->patches)
  {
    int v, o;
    unsigned char *cp;
    Patch *p = s->patches;
    s->patches = s->patches->next;
    switch (p->rel)
    {
    case REL_abs:
    case REL_abs32:
      v = value;
      break;
    case REL_16:
      v = value - p->location - 2;
      break;
    case REL_8:
      v = value - p->location - 1;
      break;
    }
    cp = outbin + p->location;
    switch (p->rel)
    {
    case REL_abs32:
      o = *((int *)cp);
      break;
    case REL_abs:
    case REL_16:
      o = (signed short)(cp[0] | (cp[1] << 8));
      break;
    case REL_8:
      o = (signed char)(cp[0]);
      break;
    }
    o += v;
    switch (p->rel)
    {
    case REL_abs32:
      *((int *)cp) = o;
      break;
    case REL_abs:
    case REL_16:
      cp[1] = o>>8;
      cp[0] = o;
      break;
    case REL_8:
      if (o > 127 || o < -128)
      {
	/* So far away from me
	   So far I just can't see
	   So far away from me
	   You're so far away from me
	   -- from `So far away' by Mark Knopfler.  */
	fprintf(stderr, "%s:%d: 8-bit relocation too big (%d); use long form\n", inname, p->lineno, o);
	total_errors++;
      }
      cp[0] = o;
      break;
    }
    free(p);
  }
  if (istemp(s->name, 'f'))
    s->defined = 0;
  return s;
}

void sortsyms(int (*sortf)(void const *,void const *))
{
  int ns, i;
  Symbol *s, **st;
  if (!symtab)
    return;
  for (s=symtab, ns=0; s; s=s->next)
    ns ++;
  st = (Symbol **)malloc(sizeof(Symbol *) * ns);
  for (s=symtab, ns=0; s; s=s->next, ns++)
    st[ns] = s;
  qsort(st, ns, sizeof(Symbol *), sortf);
  for (i=0; i<ns-1; i++)
    st[i]->next = st[i+1];
  st[i]->next = 0;
  symtab = st[0];
  free(st);
}

void emit(void *ptr, int len)
{
  while (pc + len > outsize)
  {
    outsize += 512;
    outbin = realloc(outbin, outsize);
  }
  set_lineaddr();
  memcpy(outbin+pc, ptr, len);
  pc += len;
}

void emitb(int b)
{
  emit(&b, 1);
}

void emitw(int w)
{
  emitb(w);
  emitb(w>>8);
}

void emitd(long d)
{
  emitw(d);
  emitw(d>>16);
}

void emits(Symbol *s, int offset, int rel)
{
  Patch *p;
  int v;
  if (s->defined)
  {
    switch (rel)
    {
    case REL_abs32:
      v = s->value + offset;
      emitd(v);
      break;
    case REL_abs:
      v = s->value + offset;
      emitw(v);
      break;
    case REL_16:
      v = s->value - pc - 2 + offset;
      emitw(v);
      break;
    case REL_8:
      v = s->value - pc - 1 + offset;
      if (v < -128 || v > 127)
      {
	fprintf(stderr, "%s:%d: 8-bit relocation too big (%d); use long form", inname, lineno, v);
	total_errors++;
      }
      emitb(v);
      break;
    }
    return;
  }
  p = (Patch *)malloc(sizeof(Patch));
  p->next = s->patches;
  s->patches = p;
  p->location = pc;
  p->lineno = lineno;
  p->rel = rel;
  switch (rel)
  {
  case REL_abs32:
    emitd(offset);
    break;
  case REL_abs:
  case REL_16:
    emitw(offset);
    break;
  case REL_8:
    if (offset < -128 || offset > 127)
    {
      fprintf(stderr, "%s:%d: 8-bit relocation offset too big (%d); use long form", inname, lineno, offset);
      total_errors++;
    }
    emitb(offset);
    break;
  }
}

void modrm(int mod, int reg, int rm)
{
  emitb((mod<<6) | (reg<<3) | rm);
}

int reg2mbyte[] = { 0x48, 0x88, 0x60, 0xa0, 0x40, 0x80, 0x20, 0x08 };

void reg(int which)
{
  int i;
  int v;
  int mbyte = which << 3;

  if (_modrm.regs == 0)
  {
    emitb(movacc ? movacc : mbyte + 6);
    movacc=0;
  }
  else if (_modrm.regs == 0x20 && _modrm.offset == 0 && _modrm.nsyms == 0)
  {
    emitb(mbyte + 0x86);
  }
  else
  {
    for (i=0; i<8; i++)
      if (reg2mbyte[i] == _modrm.regs)
      {
        mbyte |= i;
        break;
      }
    if (i == 8)
    {
      printf("%s:%s: Invalid registers in R/M\n", inname, lineno);
      total_errors ++;
    }
    if (_modrm.offset == 0 && _modrm.nsyms == 0)
    {
      emitb(mbyte);
      _modrm.nsyms = _modrm.regs = _modrm.offset = 0;
      return;
    }
    emitb(mbyte + 0x80);
  }
  v = _modrm.offset;
  for (i=0; i<_modrm.nsyms; i++)
  {
    Symbol *s = _modrm.syms[i];
    if (s->defined)
      v += s->value;
    else
    {
      Patch *p;
      p = (Patch *)malloc(sizeof(Patch));
      p->next = s->patches;
      s->patches = p;
      p->location = pc;
      p->lineno = lineno;
      p->rel = REL_abs;
    }
  }   
  emitw(v);
  _modrm.nsyms = _modrm.regs = _modrm.offset = 0;
}

int yylex()
{
  last_tret = yylex1();
  return last_tret;
}

static struct {
  char c1, c2;
  int token;
} twochars[] = {
  '=', '=', '=',
  '>', '=', OP_GE,
  '<', '=', OP_LE,
  '<', '>', OP_NE,
  '!', '=', OP_NE,
  '&', '&', OP_AND,
  '|', '|', OP_OR,
  '<', '<', OP_SHL,
  '>', '>', OP_SHR};

int yylex1()
{
  int c, c2, i, oldc;
  struct opcode *opp, op;

  do {
    c = fgetc(infile);
  } while (c == ' ' || c == '\t');

  switch (c)
  {
    case EOF:
      if (file_stack)
      {
        FileStack *tmp = file_stack;
        fclose(infile);
        free(inname);
        lineno = file_stack->line + 1; /* Correct for .include line */
        infile = file_stack->f;
        inname = file_stack->name;
        file_stack = file_stack->prev;
        free(tmp);
        return yylex1();
      }
      return 0;

    case 'a' ... 'z':
    case 'A' ... 'Z':
    case '_':
    case '$':
    case '.':
    case '@':
      ungetc(c, infile);
      fscanf(infile, "%[a-zA-Z0-9_$.@]", strbuf);
      strcpy(last_token, strbuf);
      if (strcmp(strbuf, ".") == 0)
        return PC;
      op.name = strbuf;
      opp = bsearch (&op,
		     opcodes, 
		     sizeof (opcodes) / sizeof (opcodes[0]),
		     sizeof (opcodes[0]),
		     opcode_compare);
      if (opp)
	{
	  yylval.i = opp->attr;
	  return opp->token;
	}
      else
	{
	  yylval.sym = get_symbol(strbuf,1);
	  return yylval.sym->defined ? KID : UID;
	}

    case '0' ... '9':
      ungetc(c, infile);
      fscanf(infile, "%i", &(yylval.i));
      sprintf(last_token, "%d", yylval.i);
      return NUMBER;
      break;

    case '>':
    case '<':
    case '!':
    case '&':
    case '|':
    case '=':
      c2 = fgetc (infile);
      for (i = 0; i < 9; i++)
	if (c == twochars[i].c1 && c2 == twochars[i].c2)
	  return twochars[i].token;
      ungetc (c2, infile);
      return c;

    case '"':
    case '\'':
      oldc = c;
      i = 0;
      while (1)
      {
        c = fgetc(infile);
        if (c == oldc)
        {
          strcpy(last_token, strbuf);
          strbuflen = i;
          if (strbuflen == 1)
          {
            yylval.i = strbuf[0];
            return NUMBER;
          }
          return STRING;
	}
        switch (c)
        {
          case '\\':
            switch (c = fgetc(infile))
            {
              case '0':
                strbuf[i++] = 0;
                break;
              case 'n':
                strbuf[i++] = '\n';
                break;
              case 'r':
                strbuf[i++] = '\r';
                break;
              case 't':
                strbuf[i++] = '\t';
                break;
              default:
                strbuf[i++] = c;
                break;
            }
            break;
          default:
            strbuf[i++] = c;
            break;
        }
      }
      abort ();
    case ';':
      while (fgetc(infile) != '\n');
      c = '\n';
      /* Fall through.  */
    case '\n':
      strcpy(last_token, "NL");
      return c;
    default:
      sprintf(last_token, "<%c>", c);
      return c;
  }
}

int istemp(char *symname, char which)
{
  if (symname[0] != '@') return 0;
  if (which)
    if (symname[1] != which) return 0;
  else
    if (symname[1] != 'f' && symname[1] != 'b') return 0;
  if (!isdigit(symname[2])) return 0;
  if (symname[3]) return 0;
  return 1;
}

void do_sreg_pop(int sreg)
{
  switch (sreg)
  {
    case 0: /* es */
      emitb(0x07);
      break;
    case 1: /* cs */
      yyerror("Cannot pop CS");
      break;
    case 2: /* ss */
      emitb(0x17);
      break;
    case 3: /* ds */
      emitb(0x1f);
      break;
    case 4: /* fs */
      emitb(0x0f);
      emitb(0xa1);
      break;
    case 5: /* gs */
      emitb(0x0f);
      emitb(0xa9);
      break;
  }
}

void do_sreg_push(int sreg)
{
  switch (sreg)
  {
    case 0: /* es */
      emitb(0x06);
      break;
    case 1: /* cs */
      emitb(0x0e);
      break;
    case 2: /* ss */
      emitb(0x16);
      break;
    case 3: /* ds */
      emitb(0x1e);
      break;
    case 4: /* fs */
      emitb(0x0f);
      emitb(0xa0);
      break;
    case 5: /* gs */
      emitb(0x0f);
      emitb(0xa8);
      break;
  }
}

void set_lineaddr()
{
  static int last_lineno = -1;
  if (lineno == last_lineno)
    return;
  last_lineno = lineno;
  if (num_lineaddr == max_lineaddr)
  {
    max_lineaddr += 32;
    if (lineaddr)
      lineaddr = (lineaddr_s *)realloc(lineaddr, max_lineaddr * sizeof(lineaddr_s));
    else
      lineaddr = (lineaddr_s *)malloc(max_lineaddr * sizeof(lineaddr_s));
  }
  lineaddr[num_lineaddr].line = lineno;
  lineaddr[num_lineaddr].addr = pc;
  num_lineaddr++;
}

void do_align(int p2, int val)
{
  last_align_begin = pc;
  while ((pc+EXE_HEADER_SIZE) % p2)
    emitb(val);
  last_align_end = pc;
}

void add_copyright(char *buf)
{
  char *tmp;
  if (copyright == 0)
  {
    copyright = (char *)malloc(strlen(buf)+1);
    strcpy(copyright, buf);
    return;
  }
  tmp = (char *)malloc(strlen(copyright) + strlen(buf) + 3);
  strcpy(tmp, copyright);
  strcat(tmp, "\r\n");
  strcat(tmp, buf);
  free(copyright);
  copyright = tmp;
}

void add_rcs_ident(char *buf)
{
  char tmp[500];
  time_t now;
  struct tm *tm;
  time(&now);
  tm = localtime(&now);
  sprintf(tmp, "$Id: %s built %02d/%02d/%02d %02d:%02d:%02d by djasm $\n",
	  inname,
	  tm->tm_mon + 1,
	  tm->tm_mday,
	  tm->tm_year,
	  tm->tm_hour,
	  tm->tm_min,
	  tm->tm_sec);
  add_copyright(tmp);
  sprintf(tmp, "@(#) %s built %02d/%02d/%02d %02d:%02d:%02d by djasm\n",
	  inname,
	  tm->tm_mon + 1,
	  tm->tm_mday,
	  tm->tm_year,
	  tm->tm_hour,
	  tm->tm_min,
	  tm->tm_sec);
  add_copyright(tmp);
}

void set_out_type(char *t)
{
  int i;
  for (i=0; ext_types[i]; i++)
  {
    if (strcmp(ext_types[i], t) == 0)
    {
      out_type = i;
      return;
    }
  }
  printf("Unknown output type: `%s'\n", t);
}

void set_image_type(char *t)
{
  int i;
  for (i=0; ext_types[i]; i++)
  {
    if (strcmp(ext_types[i], t) == 0)
    {
      if (i == OUT_com && image_type != OUT_com)
      {
        if (pc)
        {
          fprintf(stderr, "Cannot make com file without .type \"com\"\n");
          exit(1);
        }
        while (pc < 0x100)
          emitb(0x90);
      }
      image_type = i;
      return;
    }
  }
  printf("Unknown output type: `%s'\n", t);
}

void do_include(char *fname)
{
  FILE *f;
  FileStack *fs;
  
  f = fopen(fname, "r");
  if (!f)
  {
    fprintf(stderr, "Error: cannot open %s\n", fname);
    perror("The error was");
    return;
  }
  fs = (FileStack *)malloc(sizeof(FileStack));
  fs->line = lineno;
  fs->prev = file_stack;
  fs->f = infile;
  fs->name = inname;
  file_stack = fs;

  infile = f;
  inname = (char *)malloc(strlen(fname)+1);
  strcpy(inname, fname);
  lineno = 1;
}

/* #define DEBUG_RELOC */

void do_linkcoff (char *filename)
{
  long len;
  int f;
  char *data, *p;
  FILHDR *header;
  SCNHDR *f_thdr;		/* Text section header */
  SCNHDR *f_dhdr;		/* Data section header */
  SCNHDR *f_bhdr;		/* Bss section header */
  AOUTHDR f_ohdr;		/* Optional file header (a.out) */
  SYMENT *symbol;
  RELOC *rp;
  int cnt, i;
  void *base;
  int textbase, database, bssbase, delta;
  char smallname[9];

  f = open (filename, O_RDONLY );
  if (f < 0)
    {
      fprintf (stderr, "Error: cannot open %s\n", filename);
      perror("The error was");
      return;
    }
  len = lseek (f, 0L, SEEK_END);
  lseek (f, 0L, SEEK_SET);
  data = alloca (len);
  read (f, data, (unsigned)len);
  close (f);

  header = (FILHDR *) data;
  f_thdr = (void *)data + sizeof (FILHDR) + header->f_opthdr;
  f_dhdr = f_thdr + 1;
  f_bhdr = f_dhdr + 1;
  if (I386BADMAG (*header)
      || header->f_nscns != 3
      || strcmp (f_thdr->s_name, _TEXT)
      || strcmp (f_dhdr->s_name, _DATA)
      || strcmp (f_bhdr->s_name, _BSS))
    {
      fprintf (stderr, "The file %s is not a valid COFF file.\n", filename);
      return;
    }

  textbase = pc;
  emit(data + f_thdr->s_scnptr, f_thdr->s_size);
  database = pc;
  emit(data + f_dhdr->s_scnptr, f_dhdr->s_size);
  bssbase = pc;
  for (i = 0; i < f_bhdr->s_size; i++)
    emitb (0);

#ifdef DEBUG_RELOC
  printf ("textbase is at %04x\n", textbase);
  printf ("database is at %04x\n", database);
  printf ("bssbase  is at %04x\n", bssbase);
#endif

  symbol = (void *) data + header->f_symptr;
  base = (void *) symbol + header->f_nsyms * SYMESZ;
  for (cnt = header->f_nsyms; cnt > 0; symbol++, cnt--)
    {
      if (symbol->e.e.e_zeroes == 0)
	p = base + symbol->e.e.e_offset;
      else
	strncpy (p = smallname, symbol->e.e_name, 8),
	p[8] = 0;

      switch (symbol->e_sclass)
	{
	case C_EXT:
	  switch (symbol->e_scnum)
	    {
	    case 1:
	      set_symbol (get_symbol (p, 1),
			  textbase + symbol->e_value)->type |= SYM_code;
	      break;
	    case 2:
	      set_symbol (get_symbol (p, 1),
			  textbase + symbol->e_value)->type |= SYM_data;
	      break;
	    case 3:
	      set_symbol (get_symbol (p, 1),
			  textbase + symbol->e_value)->type |= SYM_data;
	      break;
	    case N_UNDEF:
	      if (symbol->e_value == 0)
		0;  /* Nothing -- external reference.  */
	      else if (!get_symbol (p, 0))
		{
		  /* New common variable.  */
		  set_symbol (get_symbol (p, 1), pc)->type |= SYM_data;
		  for (i = 0; i < symbol->e_value; i++)
		    emitb (0);
		}
	      break;
	    }
	  break;
	}
      cnt -= symbol->e_numaux;
      symbol += symbol->e_numaux;
    }

  symbol = (void *) data + header->f_symptr;
  for (i = 0; i < 2; i++)
    {
      if (i == 0)
	rp = (RELOC *) (data + f_thdr->s_relptr),
	cnt = f_thdr->s_nreloc;
      else
	rp = (RELOC *) (data + f_dhdr->s_relptr),
	cnt = f_dhdr->s_nreloc;

      for (; cnt > 0; cnt--, rp++)
	{
	  Symbol *s;
	  int delta;

	  if (symbol[rp->r_symndx].e.e.e_zeroes == 0)
	    p = base + symbol[rp->r_symndx].e.e.e_offset;
	  else
	    strncpy (p = smallname, symbol[rp->r_symndx].e.e_name, 8),
	    p[8] = 0;

#ifdef DEBUG_RELOC
	  s = get_symbol (p, 0);
	  printf ("ofs=%04x  typ=%02x  sec=%d"
		  "  val=%08x  data=%08x"
		  "  name=%s\n",
		  rp->r_vaddr + textbase,
		  rp->r_type,
		  symbol[rp->r_symndx].e_scnum,
		  s ? s->value : 0, 
		  *((int *) (outbin + textbase + rp->r_vaddr)),
		  p);
#endif
	  if (!strcmp (p, _TEXT))
	    delta = textbase;
	  else if (!strcmp (p, _DATA))
	    delta = textbase;
	  else if (!strcmp (p, _BSS))
	    delta = textbase;
	  else
	    {
	      s = get_symbol (p, 1);
	      if (!s->defined)
		{
		  Patch *pat = (Patch *) malloc (sizeof (Patch));

		  if (rp->r_type == RELOC_REL32)
		    fprintf (stderr,
			     "Call from COFF file to (yet) undefined "
			     "destination, %s, is not supported.\n", p);
		  pat->next = s->patches;
		  s->patches = pat;
		  pat->location = textbase + rp->r_vaddr;
		  pat->lineno = -1;
		  pat->rel = REL_abs32;
		}
	    }

	  switch (rp->r_type)
	    {
	    case RELOC_ADDR32:
	      if (symbol[rp->r_symndx].e_scnum > 0)
		delta = textbase;
	      else
		delta = s->value - symbol[rp->r_symndx].e_value;
	      break;
	    case RELOC_REL32:
	      if (symbol[rp->r_symndx].e_scnum > 0)
		delta = 0;
	      else
		delta = s->value - textbase;
	      break;
	    default:
	      fprintf (stderr,
		       "COFF file %s contains bad relation "
		       "entry type (0x%02x).\n",
		       filename, rp->r_type);
	      delta = 0;
	    }
	  *((int *)(outbin + textbase + rp->r_vaddr)) += delta;
	}
    }
}

